<DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html>
<head>
 <title>Manual de PAWS</title>
 <link rel="stylesheet" type="text/css"
       href="../../../css/default.css" title="CSS por defecto">
</head>
<body>

<div id="menu">
<?php
  $seccion="spectrum";
  $subseccion="aventura";
  include "../../../menu.php";
?>
</div>


<div id="central">
<a name="arriba"></a>


<h1>Manual de PAWS</h1>

<center>
[Anterior] -
<a href="paws2.php">[Siguiente]</a><br><br>
</center>

<a name="terminal"></a>
<a name="arriba"></a>
<h1>Introducci&oacute;n</h1>
<p>
Bienvenido al mundo del escritor de aventuras...<p>
El PAW o Professional Adventure Writer te ofrece todas las facilidades para producir aventuras gr&aacute;ficas de alta calidad en c&oacute;digo m&aacute;quina.<p>
PAW te proporciona una base estructurada para poder escribir el juego, pero sigue siendo tarea del escritor el tener un gui&oacute;n imaginativo e ideas originales.<p>
Los manuales que vienen con PAW cubren todos los aspectos de su uso. Este manual primero servir&aacute; como gu&iacute;a para crear una aventura y recomendamos su lectura detenida y el ejercicio de sus ejemplos antes de intentar hacer un juego propio.<p>
El segundo manual da una informaci&oacute;n detallada de todo el sistema y debe ser usado como libro de referencia al escribir una aventura.<p>
El equipo de Aventuras AD le desea buena suerte y espera sus interesantes producciones.

<p>
<h2>Empezando</h2>
La cinta contiene el programa principal en el lado 1, siendo el mismo programa para los usuarios de 48k y 128k.<p>
Inserta la cinta y teclea:<p>
<center>
LOAD "" luego ENTER y PLAY en el cassette
</center><p>
En el 128k usa la opci&oacute;n LOAD del men&uacute; inicial. Si cargas PAW en el modo 48k en un 128k, este se comportar&aacute; como si fuera la versi&oacute;n de 48k. Es preferible cargar PAW en el modo 128k.<p>
En la pantalla inicial de carga se mostrar&aacute; la versi&oacute;n actual (una letra seguida de dos d&iacute;gitos, por ejemplo A01).<p>
Tambi&eacute;n se mostrar&aacute;n dos direcciones en decimal que ser&aacute;n neesarias si quieres escribir tus propias adiciones al PAW, sea en BASIC o en C&Oacute;DIGO M&Aacute;QUINA. Para detalles consulta el manual t&eacute;cnico.<p><br>
<center>
<img src="img/img1-1.png" border="0">
</center><br>
Al apretar cualquier tecla aparecer&aacute; el men&uacute; principal...<p>
En este manual cualquier orden que sea requerida por PAW se pondr&aacute; entre corchetes, por ejemplo <b>[ A 1 CAJA ]</b> y debe de teclear exactamente todo lo  que haya dentro de los corchetes, <i>incluidos los espacios</i>, pero no los corchetes.<p>
Tambi&eacute;n las teclas especiales se muestran en may&uacute;sculas, por ejemplo ENTER, CAPS SHIFT, etc. pero no las teclees completas, solo pulsa la tecla requerida o la combinaci&oacute;n de teclas.<p>
Cualquier comunicaci&oacute;n sobre PAW debe ser dirigida a: <p><br>
<center><b>
AVENTURAS AD. S.A.<p>
Apartado 61<br>
46920 - MISLATA (Valencia)<br>
</center></b>
<br>
<p>
<h2>Conceptos</h2>
Es una buena idea introducir algunos conceptos importantes utilizados por PAW.
<ul>
<li><b>Secciones de datos</b><br>
Durante muchos a&ntilde;os ha sido de pr&aacute;ctica com&uacute;n en los ordenadores que utilizan disco como soporte principal, el partir los programas largos en dos o m&aacute;s secciones que se cargan desde el disco cuando se van a utilizar. Este sistema no ha sido muy utilizado en cintas por su misma naturaleza como contenedor de datos en forma seriada.<p>
PAW usa una forma muy simple para dejar el m&aacute;ximo de memoria libre, tanto en 48k como en 128k. Utiliza la memoria disponible para ir guardando porciones de datos hasta el momento en que esa memoria va siendo usada y sobrescrita. Los datos entonces se van obteniendo de cinta seg&uacute;n se requieran.<p>
En un 128k no hay necesidad de procuparse por las secciones de datos hasta que las &uacute;ltimas 16 k son usadas (es decir, hasta cuando se lleva escrita una aventura de &iexcl;cerca de 92k!).<p>
En 48k las secciones se empezar&aacute;n a necesitar en el momento de usar los gr&aacute;ficos o al llevar escritas ya 16 k de programa.<p>
La muestra en este manual no necesita secciones extra de datos as&iacute; que su uso se epxplicar&aacute; en detalle m&aacute;s adelante.
</li>
<li><b>Paginaci&oacute;n de memoria</b><br>
El 128k usa un sistema llamado paginaci&oacute;n para obtener su memoria extra; el <b>diagrama 1</b> ayudar&aacute; a visualizar su composici&oacute;n. En &eacute;l se ve que la parte superior se puede mover como una diapositiva en un proyector para que cada una de las p&aacute;ginas de 16k se pueda acomodar en un ordenador que solo puede ver 64k cada vez. <p><br>
<center>
<table>
<tr><td><img src="img/img1-2.png" border="0"></td></tr>
<tr><td><center><b>diagrama 1</b></center></td></tr>
</table>
</center><br>
<b>Nota:</b> las p&aacute;ginas 2 y 5 son el &aacute;rea de memoria donde se localiza el PAW y por ello no est&aacute;n disponibles. La zona de memoria marcada como <i>secciones de datos</i> ser&aacute; usada por PAW si es necesario- (ver secci&oacute;n anterior).<p>
</li>
<li><b>Base de Datos (BD)</b><br>
PAW guarda el juego en una base de datos (una colecci&oacute;n de tablas e informaci&oacute;n que definen el juego que se est&aacute; escribiendo). Inicialmente la bd es muy peque&ntilde;a y solo contiene las palabras y &oacute;rdenes m&aacute;s comunes en estos juegos.<p>
Esta base de datos va poco a poco usando el &aacute;rea de memoria que se muestra como libre en el <b>diagrama 1</b>.<p>
PAW tambi&eacute;n puede hacer uso de otras p&aacute;ginas, pero en un 48k esas p&aacute;ginas extra no estar&aacute;n disponibles, lo que significa que si se usa un 128k para escribir una aventura y se quiere que &eacute;sta corra tanto en un 128k como en un 48k, no se debe usar otra p&aacute;gina sino la principal (la 0).
</li>
<li><b>Parser</b><br>
To Parse: clasificar una palabra o analizar una frase en sus t&eacute;rminos gramaticales.<p>
PAW convierte lo tecleado por el jugador en una serie de <i>sentencias l&oacute;gicas (SL)</i> para las cuales ya hay una respuesta definida.<p>
Esto se hace extrayendo frases de la cadena de <i>input</i>, de una en una y dejando que el int&eacute;rprete las descifre.<p>
Las frases pueden ir separadas por cualquier signo de puntuaci&oacute;n y por las conjunciones <i>y, entonces, o luego</i> (o la que se haya definido).<p>
Cuando ya no hay mas frases en la actual cadena de input, se pide otra al jugador<p>
Una frase debe consistir al menos en un <b>verbo</b> (indica acci&oacute;n), opcionalmente dos <b>nombres</b> (objetos o personajes), posiblemente asociados a <b>adjetivos</b> (que los describen), de <b>adverbios</b> (que modifican el verbo), de una <b>preposici&oacute;n</b> (que muestra la relaci&oacute;n de un nombre con otra palabra), y tambi&eacute;n puede obtener una "cadena entre comillas para hablar con otros personajes".
</li>
</ul>
<br>

<h2>Men&uacute;</h2>
Del men&uacute; principal, mostrado al pulsar cualquier tecla desde la p&aacute;gina de t&iacute;tulo, se puede acceder a cualquier opci&oacute;n del PAW con solo teclear una sola letra (en MAY&Uacute;SCULAS) seguida de ENTER.<p>
El men&uacute; est&uacute; dividido en dos partes y la opci&oacute;n E permite cambios entre ellas.<p><br>

<center>
<img src="img/img1-3.png" border="0"><br><p>
<img src="img/img1-4.png" border="0"><br>
</center><br>

 La parte inicial muestra todas las funciones necesarias para crear un juego. La segunda (accesible con E) contiene todo lo necesario para Salvar, Cargar , Verificar, Probar el juego, etc. y tambi&eacute;n el dise&ntilde;ador de car&aacute;teres y el compresor de textos (se explicar&aacute;n m&aacute;s adelante).<p>
Si te encuentras con la pregunta: &iquest;carga de la secci&oacute;n de datos?. es porque la parte a usar no est&aacute; presente en ese momento y requiere que se cargue de memoria externa (ver secciones de datos). Entonces se requerir&aacute; teclear si o no, ENTER. En el momento actual no la necesitaremos = no, ENTER.
<ul>
<li><b>L&iacute;nea de edici&oacute;n</b><br>
Similar a la de input en basic; se pueden usar las teclas de cursor para moverse a derecha e izquierda y DELETE para borrar lo que es&aacute; a la izquierda del cursor.<p>
EDIT debe ser tecelado dos veces, o apretado hasta que se autorrepita para limpiar cualquier cosa que se haya tecleado.<p>
CURSOR y ABAJO (6) debe ser tecleado dos veces o apretado hasta que se repita para abandonar el texto presente. La diferencia es que aqu&iacute; se deja el texto que se estaba escribiendo en la base de datos y con EDIT se borra todo.
</li>
<li><b>Memoria libre</b><br>
Con F se muestra la memoria disponible en cada p&aacute;gina. En 48k se referir&aacute; solo a la p&aacute;gina 0.<p>
Adem&aacute;s, se muestra tambi&eacute;n la localidad y el mensaje mas alto usados hasta el momento. La raz&oacute;n de esta informaci&oacute;n tan &uacute;til se explica mas adelante. Apretando cualquier tecla se vuelve al men&uacute;
</li>
<li><b>Salvando, cargando y verificando la base de datos</b><br>
Como es obvio que no se puede terminar un juego de una sola sentada y existe el peligro de p&eacute;rdidad de informaci&oacute;n por cualquier fallo del sistema, estas opciones permiten pasar a cinta o a disco un fichero con toda la informaci&oacute;n. <br>
Con S se pedir&aacute; un nombre de fichero; te sugerimos ponerle un nombre que sea significativo y que contenga el n&uacute;mero de la versi&oacute;n o la fecha.<p>
La bd se salvar&aacute; en varias partes. PAW salva dos ficheros por p&aacute;gina, cambiando la &uacute;ltima letra del nombre a A, B, C, etc para cada uno usado.<p>
Con H se verificar&aacute; la bd salvada comprob&aacute;ndola con la que hay en memria. Si se detecta un error, entonces hay que volver a salvar la bd en una cinta diferente si es necesario<br>
Con J se pide el nombre de la bd que se desee cargar de nuevo dentro de PAW. <i>Cualquier base de datos que se encuentre presente dentro de PAW se borrar&aacute; para dejar paso a la nueva</i>.<p>
Si se produce un error de carga, se corromper&aacute; todo el &aacute;rea donde se aloja la bd y la &uacute;nica opci&oacute;n que se debe hacer es continuar con la J hasta que la bd se haya cargado satisfactoriamente, Cualquier otra opci&oacute;n producir&aacute; da&ntilde;o al programa propio de PAW y se necesitar&aacute; una recarga completa.<br>
Regla: salva tu base de datos regularmente y en cintas diferentes para tener as&iacute; un resguardo en caso de producirse el cl&aacute;sico corte de luz u otro accidente cualquiera.
</li>
</ul>

<p><br>
<center>
[Anterior] -
<a href="paws2.php">[Siguiente]</a><br><br>
</center>
<a href="#arriba">[Ir arriba]</a><br>
<a href="../paws.php">[Pgina sobre PAWS]</a><br>

<p>
<?php include "../../../end.php"; ?>

</div>

</body>
</html>

