<DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html>
<head>
 <title>Manual de PAWS</title>
 <link rel="stylesheet" type="text/css"
       href="../../../css/default.css" title="CSS por defecto">
</head>
<body>

<div id="menu">
<?php
  $seccion="spectrum";
  $subseccion="aventura";
  include "../../../menu.php";
?>
</div>


<div id="central">
<a name="arriba"></a>


<h1>Manual de PAWS (X)</h1>

<center>
<a href="paws9.php">[Anterior]</a> -
<a href="paws11.php">[Siguiente]</a><br><br>
</center>

<a name="terminal"></a>
<a name="arriba"></a>


<h1>Personajes</h1><br>
<h2>El pajarito</h2><br>
El juego de pr&aacute;ctica que hemos hecho es bastante f&aacute;cil de resolver (bastante tontito,
la verdad). As&iacute; que le vamos a a&ntilde;adir un poco de complejidad creando dos caracteres que vayan
vagando por nuestro peque&ntilde;o mundo. Estos caracteres son llamados PSI, o Caracteres Pseudo Inteligentes,
porque es obvio que aunque no pueden pensar, debe de parecerle al jugador como si lo hiciesen.<p>
Un PSI consiste principalmente en una colecci&oacute;n de mensajes, banderas y entradas en
tablas de procesos. Ver&aacute;s que con unas pocas entradas simples se pueden crear efectos
sorprendentemente reales.<p>
La creaci&oacute;n de un complejo PSI puede tomar mucho m&aacute;s tiempo, pero en general sigue
los mismos principios que los que vamos a hacer con los nuestros: un pajarito y un perrito.<p>
El p&aacute;jaro se pone para complicar el escenario de la siguiente manera: coger&aacute; el billete al principio del juego
(normalmente se le dar&iacute;a una localidad no usada como contenedor de los objetos que lleve el p&aacute;jaro, pero
nosotros usaremos la localidad 252, puesto que solamente tenemos un PSI que puede tener un objeto).<p>
De modo que el jugador debe convecner al pajarito para que deje caer el billete. El intentar
quit&aacute;rselo o cogerlo dar&aacute; el mensaje "No puedo hacer eso", y har&aacute; que el pajarito se
vaya volando hacia otra parte.<p>
El pajarito tambi&eacute;n dar&aacute;la paliza volando entre el pabell&oacute;n de m&uacute;sica y una ramita del &aacute;rbol,
y esto lo har&aacute; a intervalos regulares. La &uacute;nica manera de convencer al pajarito
para que deje caer el billete de autob&uacute;s es dejar caer el emparedado en la misma localidad.<p>
Lo primero que hay que hacer es ir a la tabla de Objetos Inicialmente En (la tabla I) y cambiar el
objeto 4 a no creado, es decir, darle al objeto 4, que es el billete, el valor de 252.<p>
Esto hace que el objeto no exista como objeto, porque lo lleva el pajarito en el pico.<p>
En el vocabulario insertamos tambi&eacute;n los nombres pajarito o p&aacute;jaro y perro. Supondremos
que el p&aacute;jaro es 22 y el perro es 21, <u>perro=21, p&aacute;jaro=22</u>, porque sus valores
como palabras ser&aacute;n usados para poner las entradas en el orden correcto en las tablas
de procesos.<p>
Despu&eacute;s, insertamos los siguientes mensajes. Podemos usar tinta verde (en MODO EXTENDIDO,
CAPS SHIFT + 4) para los mensajes, <u>no olvidando volver a poner tinta blanca al final</u> (MODO EXTENDIDO,
CAPS SHIFT + 7).<p>
<br><blockquote>
MODO EXTENDIDO + CAPS SHIFT + NUMERO = EL COLOR DE LA TINTA
</blockquote><br>
Mensaje 6<br>
<blockquote>
El pajarito deja caer el billete para coger el emparedado
</blockquote><br>
Mensaje 7<br>
<blockquote>
El pajarito se lleva velozmente el billete
</blockquote><br>
Mensaje 8<br>
<blockquote>El pajarito me ignora</blockquote><br>
Mensaje 9<br>
<blockquote>Un pajarito anda rondando por aqu&iacute;</blockquote><br>
Mensaje 10<br>
<blockquote>El pajarito tiene un billete en su pico</blockquote><br>
Mensaje 11<br>
<blockquote>Un prqueo pajarito se posa en la hierba</blockquote><br>
Mensaje 12<br>
<blockquote>El pajarito est&aacute; ahora en la rama del &aacute;rbol</blockquote><br>
Mensaje 13<br>
<blockquote>El pajarito ve al perro y sale pitando</blockquote><br>
Mensaje 14<br>
<blockquote>El pajarito se va</blockquote><br>
Luego pondremos los mensajes que vaya a usar el perro, pero ahora debemos seleccionar la tabla de Procesos y
prepararnos para otras de las virguer&iacute;as de PAW.<p>
<h2>Sub-procesos</h2><br>
En una aventura de verdad que contenga varios PSI y un mont&oacute;n de acciones, las tablas de
procesos 1 y 2 pronto acabar&aacute;n llenas, y se hace cada vez m&aacute;s dif&iacute;cil trabajar
de esta forma. Entonces viene el momento de dejar que las otras tablas de Procesos comiencen
a actuar. Estas pueden ser <u>llamadas desde las tablas de Procesos 1 y 2 o de la tabla de Respuestas</u>,
y usadas como una extensi&oacute;n de la tabla desde la cual fueron llamadas.<p>
El llamar a otro proceso hace que PAW guarde en memoria d&oacute;nde estaba en el momento de ser llamado, y continuar&aacute;a actuando en la misma forma en que lo estaba
haciendo. Por ejemplo, si se llam&oacute; desde una tabla de Respuestas, PAW tratar&aacute; de hacer coincidir la
Sentencia L&oacute;gica actual con cualquier otra entrada. Pero si es llamado desde una tabla
de Procesos, sea la 1 o la 2, PAW sencillamente ejecutar&aacute; cada entrada (ESTO ES MUY IMPORTANTE).<p>
Por otra parte, cuando algo es DONE en el Proceso llamado, PAW volver&aacute; a la tabla original y
continuar&aacute; trabajando. Por lo tanto se pueden hacer acciones bastante complejas mediante el uso de los
sub-procesos. Los usuarios que sepan algo de programaci&oacute;n reconocer&aacute; f&aacute;cilmente que
son sencillamente sub-rutinas.<p>
Cuando PAW est&aacute; en un sub-proceso, es posible que sea llamado para actuar en otro sub-proceso (un sub-sub-proceso?), y
as&iacute; se puede continuar con sub-sub-sub hasta un valor de 10.<p>
Es decir, las sub-rutinas pueden ser anidadas hasta un valor de 10. Si se intenta ir m&aacute;s lejos
saldr&aacute; la frase "Limit Reached", o sea, L&iacute;mite alcanzado.<p>
En este momento no vamos a usar un sub-proceso muy complicado, solamente uno simple,
y lo haremos para tener en cuenta todas las chorraditas del p&aacute;jaro.<p>
Usando [B] se comienza un nuevo sub-proceso y PAW autom&aacutE;ticamente te localizar&aacute; el
siguiente n&uacute;mero libre. De momento deber&iacute;amos estar comenzando el proceso 3. Como solamente
hay unas pocas entradas en la tabla, usaremos el mismo par de palabras ("_ PAJARO"), aun cuando
hay que tener en cuenta que al escribir tu juego debes de usar otras palabras que te recuerden
lo que hace cada entrada.<p>
La bandera 11, ser&aacute; una bandera de "trabajo", porque contiene un valor que se usa solamente
como comparaci&oacute;n.<p>
La bandera 12 llevar&aacute; el n&uacute;mero de la localidad actual del p&aacute;jaro.<p>
La bandera 5 es una bandera especial, porque si tiene un valor diferente de 0, disminuir&aacute; 1 cada vez
que PAW ejecute una acci&oacute;n, es decir, cada vez que PAW revise la tabla de Procesos 2. Es lo
que se llama una bandera auto-decreciente.<p>
En este caso usaremos la bandera 5 para contar el n&uacute;mero de turnos que han pasado en el
juego. Un turno del juego es toda una vuelta del circuito grande en el <a href="./img/img9-1.png">diagrama 4</a>, y
de momento, esto pasa cada vez que el jugador teclea una frase.<p>
El pajarito cambiar&aacute; de localidad cada tres frases, lo que crear&aacute; una especie de apariencia de acci&oacute;n
independiente de lo que teclee el jugador.<p>
Ahoira, vamos a insertar las siguientes entradas (sin los comentarios, como hicimos antes). En cada entrada
tenemos una explicaci&oacute;n de su prop&oacute;sito y tambi&eacute;n explicaremos cada nuevo
condacto que se use:
<br>
Primero hay que determinar si el p&aacute;jaro va a salir pitando. Esto pasar&aacute; cuando la
bandera 5 tenga el valor 0 (empezar&aacute; a contar desde 3). Entonces, si el bileete est&aacute; en
la misma localidad que la del p&aacute;jaro, ser&aacute; destruido (Puesto que la localidad 252 indica que
el p&aacute;jaro lo tiene) y si el jugador est&aacute; en la misma localidad que el p&aacute;jaro, se le dir&aacute;
que el p&aacute;jaro se ha llevado el billete.<p>
Tienes que darte cuenta de que el p&aacute;jaro sigue con sus ciclos de movimientos aunque el jugador no lo vea. De hecho,
en el mundo de PAW un &aacute;rbol se cae aunque no haya nadie para verlo. As&iacute; de real es.<p>
<br>
<table>
<tr><td>_</td><td>PAJARO</td><td>COPYOF</td><td>4</td><td>11</td><td>;Copia la localidad del objeto 4 (el billete) a la bandera 11</td></tr>
<tr><td></td><td></td><td>SAME</td><td>11</td><td>12</td><td>;y mira si est&aacute; en la misma localidad que el p&aacute;jaro</td></tr>
<tr><td></td><td></td><td>ZERO</td><td>5</td><td></td><td>;Va a volar el p&aacute;jaro?</td></tr>
<tr><td></td><td></td><td>DESTROY</td><td>4</td><td></td><td>;El p&aacute;jaro coge el billete</td></tr>
<tr><td></td><td></td><td>SAME</td><td>12</td><td>38</td><td>;Est el pjaro en la misma localidad que el jugador?</td></tr>
<tr><td></td><td></td><td>MESSAGE</td><td>7</td><td></td><td>D&iacute;selo al jugador</td></tr>
</table>
<br>
F&iacute;jate, no hay acci&oacute;n DONE porque queremos que PAW haga cada entrada, una detr&aacute;s de otra, siempre que se
cumplan los requisitos de las condiciones de ellas. La tabla anterior te muestra comose pueden
mezclar condiciones y acciones para crear nuevas condiciones.<p>
<br>
<b>COPYOF</b>: Es una acci&oacute;n que debe ser seguida por el n&uacute;mero de un objeto y una bandera. Lo
que hace es que copia la localidad actual del objeto que se especifique, en la bandera especifica. La
usamos en esta situaci&oacute;n para ver si el billete est&aacute; en la misma localidad que el
p&aacute;jaro.<p>
<br><b>SAME</b>: Es una condici&oacute;n que compara el contenido de dos banderas, y que es favorable
o positiva si ambas son del mismo valor.<p>
<br><b>DESTROY</b>: Es uan acci&oacute;n que pone un objeto especificado en la localidad 252 (localidad no creada).<p>
<br>
Ahora vamos a crear dos posibles movimientos para el p&aacute;jaro.<p>
Si el p&aacute;jaro est&aacute; en el pabell&oacute;n de m&uacute;sica y la bandera 5 ha llegado
a 0, entonces hay que mover el p&aacute;jaro, setear la bandera 5 a tres otra vez y decirle al jugador que el
pajaro se ha ido, si est&aacute; en la misma localidad. Y lo mismo si el p&aacute;jaro est&aacute;
en la rama.<p>
<br>
<table>
<tr><td>_</td><td>PAJARO</td><td>EQ</td><td>12</td><td>8</td><td>;Est&aacute; el p&aacute;jaro en la rama?</td></tr>
<tr><td></td><td></td><td>ZERO</td><td>5</td><td></td><td>;Es tiempo de volar?</td></tr>
<tr><td></td><td></td><td>LET</td><td>12</td><td>5</td><td>;Mover el p&aacute;jaro al pabell&oacute;n</td></tr>
<tr><td></td><td></td><td>LET</td><td>5</td><td>3</td><td>;Tres frases antes de moverse</td></tr>
<tr><td></td><td></td><td>AT</td><td>8</td><td></td><td>;Est&aacute; el jugador tambi&eacute;n aqu&iacute;?</td></tr>
<tr><td></td><td></td><td>MESSAGE</td><td>14</td><td></td><td>Dile que el p&aacute;jaro ha volado</td></tr>
</table>
<br>
<br>
<table>
<tr><td>_</td><td>PAJARO</td><td>EQ</td><td>12</td><td>5</td><td>;Est&aacute; el p&aacute;jaro en el pabell&oacute;n?</td></tr>
<tr><td></td><td></td><td>ZERO</td><td>5</td><td></td><td>;Es tiempo de volar?</td></tr>
<tr><td></td><td></td><td>LET</td><td>12</td><td>8</td><td>;Mover el p&aacute;jaro a la rama</td></tr>
<tr><td></td><td></td><td>LET</td><td>5</td><td>3</td><td>;Tres frases antes de moverse</td></tr>
<tr><td></td><td></td><td>AT</td><td>5</td><td></td><td>;Est&aacute; el jugador tambi&eacute;n aqu&iacute;?</td></tr>
<tr><td></td><td></td><td>MESSAGE</td><td>14</td><td></td><td>Dile que el p&aacute;jaro ha volado</td></tr>
</table>
<br>
<b>EQ</b>: Es una condici&oacute;n que debe ser seguida por un n&uacute;mero de bandera y otro
valor, y que ser&aacute; positiva si la bandera contiene ese valor. En este caso (EQ 12 8) est&aacute;
comprobando si el p&aacute;jaro est&aacute; en una localidad espec&iacute;ficada.<p>
<br><b>LET</b>: Es una acci&oacute;n que tambi&eacute;n es seguida por una bandera y un valor. Y pone
ese valor en la bandera.<p>
<br>
Ya hemos tenido en cuenta el vuelo del p&aacute;jaro. Ahora vamos a poner sus llegadas, y si llega
a una localidad donde est&aacute; el jugador, hay que dec&iacute;rselo.<p>
<br>
<table>
<tr><td>_</td><td>PAJARO</td><td>EQ</td><td>5</td><td>3</td><td>;Acaba de volar el p&aacute;jaro</td></tr>
<tr><td></td><td></td><td>SAME</td><td>12</td><td>38</td><td>Est&aacute; en la localidad del jugador?</td></tr>
<tr><td></td><td></td><td>AT</td><td>5</td><td></td><td>;o en el pabell&oacute;n de m&uacute;sica?</td></tr>
<tr><td></td><td></td><td>MESSAGE</td><td>11</td><td></td><td>;Ha aterrizado en la hierba</td></tr>
</table>
<br>
<table>
<tr><td>_</td><td>PAJARO</td><td>EQ</td><td>5</td><td>3</td><td>;Acaba de volar el p&aacute;jaro</td></tr>
<tr><td></td><td></td><td>SAME</td><td>12</td><td>38</td><td>Est&aacute; en la localidad del jugador?</td></tr>
<tr><td></td><td></td><td>AT</td><td>8</td><td></td><td>;o en la rama?</td></tr>
<tr><td></td><td></td><td>MESSAGE</td><td>11</td><td></td><td>;Ha aterrizado en la rama</td></tr>
</table>
<br>
Ahora, si el p&aacute;jaro tiene el billete en su pico debemos dec&iacute;rselo al jugador.<p>
<br>
<table>
<tr><td>_</td><td>PAJARO</td><td>EQ</td><td>5</td><td>3</td><td></td></tr>
<tr><td></td><td></td><td>SAME</td><td>12</td><td>38</td><td></td></tr>
<tr><td></td><td></td><td>ISAT</td><td>4</td><td>252</td><td>;El billete no ha sido creado?</td></tr>
<tr><td></td><td></td><td>MESSAGE</td><td>10</td><td></td><td>;Tiene el billete en su pico</td></tr>
</table>
<br>
<b>ISAT</b>: Es una condici&oacute;n seguida de un objeto y el n&uacute;mero de una
localidad y es positiva si el objeto est&aacute; en la localidad especificada.<p><br>
Finalmente, si el emparedado est&aacute; en la misma localidad que el p&aacute;jaro, el
p&aacute;jaro dejar&aacute; el billete para coger el emparedado. Esta entrada no tiene nada
que ver con la bandera 5, as&iacute; que ser&aacute; buscada cada vez que PAW vaya al Proceso 2.
Por lo tanto, si el juegador deja caer el emparedado <u>despu&eacute;s</u> de que el p&aacute;jaro
haya llegado, la secuencia correcta aun se llevar&aacute; a cabo.<p>
<br>
<table>
<tr><td>_</td><td>PAJARO</td><td>COPYOF</td><td>2</td><td>11</td><td>;emparedado</td></tr>
<tr><td></td><td></td><td>SAME</td><td>11</td><td>12</td><td>;En la misma localidad que el p&aacute;jaro?</td></tr>
<tr><td></td><td></td><td>ISAT</td><td>4</td><td>252</td><td>;Lleva el billete en el pico?</td></tr>
<tr><td></td><td></td><td>COPYFO</td><td>12</td><td>4</td><td>;Empieza a caer el billete</td></tr>
<tr><td></td><td></td><td>SAME</td><td>12</td><td>38</td><td>;Est&aacute; el jugador tambi&eacute;n por all&iacute;?</td></tr>
<tr><td></td><td></td><td>MESSAGE</td><td></td><td>6</td><td>;D&iacute;selo</td></tr>
</table>
<br>
<b>COPIFO</b>: Es una acci&oacute;n que copia el contenido de una bandera espec&iacute;fica
a la localidad actual del objeto espec&iacute;fico. Tambi&eacute;n hay acciones COPYFF y COPYOO
que son f&aacute;ciles de comprender.<p><br>
As&iacute; completamos las rutinas de control del pajarito. Pero necesitamos una entrada
en el Proceso 2 para llamar a todas esas rutinas cada ciclo, as&iacute; que busquemos en
la tabla 2 y pongamos la entrada que llama a todo el subproceso, es decir, la entrada
"madre".
<br>
<blockquote>
_ PAJARO PROCESS 3
</blockquote>
<br>
lo que har&aacute; que PAW ejecute nuestros controles de p&aacute;jaro cada vez que
pase por ah&iacute;.<p>
Ahora debemos asegurarnos de que el p&aacute;jaro empieza en la localidad correcta
y que el jugador sabe que el p&aacute;jaro est&aacute; ah&iacute; cuando la localidad
se describe (o empezar&aacute; a ver mensajes acerca de un p&aacute;jaro dando la paliza
sin haber tenido ninguna descripci&oacute;n de que existe tal pajaro).<p>
As&iacute; que seleccionamos el Proceso 1 (que ya sabemos que se llama despu&eacute;s de cada
descripci&oacute;n de localidad) y vamos a correfir la entrada existente con * *
poni&eacute;ndole un [LET 12 8], lo cual har&aacute; que el &p&aacute;jaro est&eacute; en
la rama al principio del juego. La entrada modificada debe de ser:
<br>
<table>
<tr><td>*</td><td>*</td><td>AT</td><td>0</td><td></td><td></td></tr>
<tr><td></td><td></td><td>ANYKEY</td><td></td><td></td><td></td></tr>
<tr><td></td><td></td><td>LET</td><td>12</td><td>8</td><td>;El p&aacute;jaro est&aacute; en la rama (localidad 8)</td></tr>
<tr><td></td><td></td><td>GOTO</td><td>2</td><td></td><td></td></tr>
<tr><td></td><td></td><td>DESC</td><td></td><td></td><td></td></tr>
</table>
<br>
Y tambi&eacute;n hay que poner la siguiente entrada en la tabla de Procesos, para que le diga
al jugador que hay un pajarito, y que tiene el billete.<p>
<table>
<tr><td>_</td><td>PAJARO</td><td>SAME</td><td>12</td><td>38</td><td></td></tr>
<tr><td></td><td></td><td>MESSAGE</td><td>9</td><td></td><td></td></tr>
<tr><td></td><td></td><td>ISAT</td><td>4</td><td>252</td><td></td></tr>
<tr><td></td><td></td><td>MESSAGE</td><td>10</td><td></td><td></td></tr>
</table><br>
Por &uacute;ltimo seleccionaremos la tabla de Respuestas e insertaremos la entrada:<br>
<table>
<tr><td>COGER</td><td>BILLETE</td><td>SAME</td><td>12</td><td>38</td><td>;Est&aacute; el p&aacute;jaro en la misma localidad?</td></tr>
<tr><td></td><td></td><td>ISAT</td><td>4</td><td>252</td><td>;Con el billete en el pico?</td></tr>
<tr><td></td><td></td><td>CLEAR</td><td>5</td><td></td><td>;Esto lo fuerza a volar</td></tr>
<tr><td></td><td></td><td>NOTDONE</td><td></td><td></td><td>;"No puedo hacer eso"</td></tr>
</table>
Esta entrada se disparar&aacute; antes de la entrada COGER _ y previene la respuesta
"No hay uno de esos aqu&iacute;" si el p&aacute;jaro est&aacute; presente con el billete.
<br><br>
<b>CLEAR</b>: Es una acci&oacute;n que va seguida por un n&uacute;mero de bandera,
y que pone esa bandera a 0. En este caso har&aacute, que el p&aacute;jaro salga
pitando, simulando su miedo a una gran mano que desciende sobre &eacute;l para coger
su preciada posesi&oacute;n.<p><br>
<b>NOTDONE</b>: Es una acci&oacute;n similar a DONE, pero que enga&ntilde;a a PAW
pensando que no has hecho nada y por lo tanto hace imprimir el mensaje "No puedo hacer
eso".<p><br>
Y ahora, vamos al momento de la verdad. Hay que probar el juego para ver si el
p&aacute;jaro vuela del pabell&oacute;n de m&uacute;sica a la rama. Juega un rato para ver si el
p&aacute;jaro contin&uacute;a con su existencia vagabunda. Despu&eacute;s trata de
dejar caer el emparedado en la misma localidad. Date cuenta de que si no coges el billete
antes de que el p&aacute;jaro se pire, el p&aacute;jaro lo coger&aacute; otra vez.<p>
Y menos mal que acabamos con el bendito p&aacute;jaro. Es complicado, pero te ense&ntilde;ar&aacute;
un mont&oacute;n sobre PAW.<p>

<h2>El perro</h2><br>
Este perro lo ponemos para complicar el juego un poco m&aacute;s. Simplemente
seguir&aacute; al jugador donde quiera que vaya y espantar&aacute; al pajarito.
Como no se espera que el perro se suba al &aacute;rbol, debemos impedir que el
jugador pueda tentar al p&aacute;jaro con el emparedado desde la rama. Para hacer eso
disponemos que cualquier objeto que se suelte desde la rama del &aacute;rbol
caiga hasta el suelo.<p>
El jugador se puede desembarazar del maldito perro poni&eacute;ndole la cadena
y amarr&aacute;ndola al banco. Adem&aacute;s, el jugador puede "hablar" al perro, lo
cual le dar&aacute; otro medio para desembarazarse de &eacute;l, dici&eacute;ndole
que se SIENTE o que se QUEDE.<p>
Antes de examinar las entradas en las tablas de Procesos y Respuestas., necesitamos
tener el control del perro por medio de las siguientes palabras en el vocabulario
y mensajes en la tabla de mensajes.
<br>
<table>
<tr><td>Verbos</td><td></td><td>Nombre</td><td></td></tr>
<tr><td></td><td></td><td></td><td></td></tr>
<tr><td>ATAR</td><td>34</td><td></td><td></td></tr>
<tr><td>DESATAR</td><td>35</td><td></td><td></td></tr>
<tr><td>SENTAR</td><td>36</td><td></td><td></td></tr>
<tr><td>QUEDAR</td><td>36</td><td></td><td></td></tr>
<tr><td>VEN</td><td>37</td><td>AQUI</td><td>37</td></tr>
</table><br>
Los n&uacute;meros te demuestran que sentarse y quedarse son lo mismo, y que
tambi&eacute;n usamos un Nombre y un Verbo con el mismo n&uacute;mero.<p><br>
<blockquote>
Mensaje 15<br><br>
El _ cae al suelo al pie del &aacute;rbol
</blockquote></br>
No se debe cambiar el color de este mensaje, y el que pongamos una raya baja en &eacute;l
tiene un prop&oacute;sito especial, del cual ya hablaremos m&aacute;s adelante.<p>
Los dem&aacute;s mensajes que hablen del perro pueden ser puestos de cualquier otro
color, por ejemplo magenta (MODO EXTENDIDO, CAPS SHIFT + 3) <u>no olvidando nunca volver
al blanco al final de cada uno de ellos</u>. El color del mensaje le permite al
jugador saber exactamente a qui&eacute;n se refiere cada mensaje.<p><br>
<blockquote>
Mensaje 16<br><br>
El perro me mira con amor<br><br>
Mensaje 17<br><br>
El perro est&aacute; aqu&iacute;<br><br>
Mensaje 18<br><br>
El perro me sigue moviendo la cola<br><br>
Mensaje 19<br><br>
El perro va arrastrando la correa<br><br>
Mensaje 20<br><br>
El perro est&aacute; atado al banco con una cadena<br><br>
Mensaje 21<br><br>
Confiadamente, el perro me deja ponerle la correa alrededor del cuello<br><br>
Mensaje 22<br><br>
He amarrado el perro al banco<br><br>
Mensaje 23<br><br>
A qui&eacute;n se lo digo?<br><br>
Mensaje 24<br><br>
El perro se sienta tranquilo<br><br>
Mensaje 25<br><br>
He desatado al perro del banco<br><br>
</blockquote><br>
No hay verdadera necesidad de hacer la rutina para el perro en una tabla de Procesos
separada, porque solamente hay una entrada, pero lo haremos por si quieres ampliar
el juego m&aacute;s tarde.<p>
La bandera 13 contendr&aacute; la localidad actual del perro.<p>
La bandera 14 contendr&aacute; varios indicadores:<br><br>
<blockquote>
<table>
</tr><td align="right">0</td><td>si el perro est&aacute; libre para andar por ah&iacute;</td></tr>
</tr><td align="right">1</td><td>si el perro tiene la correa alrededor del cuello</td></tr>
</tr><td align="right">2</td><td>si el perro est&aacute; atado al banco</td></tr>
</tr><td align="right">255</td><td>si el perro est&aacute; sentado muy tranquilo</td></tr>
</table>
</blockquote><br>
Desde la tabla de Procesos, con [B] empezamos una nueva tabla de Procesos (debe ser la tabla n&uacute;mero
cuatro) y ponemos una sola entrada:<br><br>
<blockquote>
<table>
<tr><td>_</td><td>PERRO</td><td>NOTSAME</td><td>12</td><td>38</td><td>No est&aacute; el perro donde est&aacute; el jugador?</td></tr>
<tr><td></td><td></td><td>LT</td><td>14</td><td>2</td><td>;Todav&iacute;a se puede mover?</td></tr>
<tr><td></td><td></td><td>NOTAT</td><td>8</td><td></td><td>;El jugador no est&aacute; arriba del &aacute;rbol?</td></tr>
<tr><td></td><td></td><td>COPYFF</td><td>38</td><td>13</td><td>;Mueve el perro a la localidad del jugador</td></tr>
<tr><td></td><td></td><td>MESSAGE</td><td>18</td><td></td><td>;y dile que lo atosigue</td></tr>
</table>
</blockquote><br>
Suponemos que eres capaz de entender qu&eacute; es NOTSAME, NOTAT y COPYFF, en caso
negativo, en la gu&iacute;a t&eacute;cnica te explicaremos para qu&eacute; sirve
cada una.<p><br>
<b>LT</b>: Es una condici&oacute;n que es positiva o favorable si la bandera especificada
contiene un valor MENOR QUE el valor especificado. En este caso [LT 14 2] solamente ser&aacute;
positivo o acertado si la bandera 14 tiene un valor menos de 2.<p>
Ahora vamos a la tabla de Procesos 2:<br><br>
<blockquote>
_ PERRO PROCESS 4
</blockquote><br>
es decir, que est&aacute;s usando la tabla de Procesos 2 para enviar a PAW a la tabla de Procesos 4.<p>
La entrada "_ Perro", (si usamos [P] para mirar la tabla), debe estar antes de la entrada del pajarito (si no es as&iacute; es que has puesto
las palabras del vocabulario de una forma diferente a como dijimos). Es para asegurar que el perro se mueva
a la nueva localidad del jugador <u>antes</u> de que el p&aacute;jaro sea comprobado.<p>
Similarmente a como hicimos con el p&aacute;jaro, se requieren entradas en la tabla de Procesos 1, para
informarle al jugador de que el perro anda por ah&iacute; rondando:<br><br>
<blockquote>
<table>
<tr><td>_</td><td>PERRO</td><td>SAME</td><td>13</td><td>38</td><td>;El perro est&aacute; en la misma localidad?</td></tr>
<tr><td></td><td></td><td>MESSAGE</td><td>17</td><td></td><td>;D&iacute;selo al jugador</td></tr>
<tr><td></td><td></td><td>EQ</td><td>14</td><td>1</td><td>;Con la correa?</td></tr>
<tr><td></td><td></td><td>MESSAGE</td><td>19</td><td></td><td>;S&iacute; diselo al jugador</td></tr>
</table><br><br>
<table>
<tr><td>_</td><td>PERRO</td><td>SAME</td><td>13</td><td>38</td><td></td></tr>
<tr><td></td><td></td><td>EQ</td><td>14</td><td>2</td><td>;Est&aacute; el perro amarrado al banco?</td></tr>
<tr><td></td><td></td><td>MESSAGE</td><td>20</td><td></td><td></td></tr>
</table><br><br>
<table>
<tr><td>_</td><td>PERRO</td><td>SAME</td><td>13</td><td>38</td><td></td></tr>
<tr><td></td><td></td><td>GT</td><td>14</td><td>2</td><td>;255 es mayor que 2, as&iacute; que</td></tr>
<tr><td></td><td></td><td>MESSAGE</td><td>24</td><td></td><td>;Dile al jugador que el perro est&aacute; sentado</td></tr>
</table></blockquote>
<br>
Ya que estamos en la tabla de Procesos 1, modifiquemos la entrada * para que tambi&eacute;n tenga [LET 13 2]
(antes del GOTO), esto hace que el perro empiece en la parada del autob&uacute;s.<p>
Ahora, para que el perro asuste al pajarito, necesitamos una entrada extra en la tabla de Procesos 3. Pero debe ir
delante de la entrada que decide que el p&aacute;jaro deje caer el billete y despu&eacute;s de la entrada
que hace que el p&aacute;jaro vuele. As&iacute; nos aseguramos que el p&aacute;jaro volar&aacute; con
el billete si lo tiene y lo deja si no lo tiene.<p>
Por lo tanto, necesitamos insertar otra entrada antes de la sexta. Usaremos [I _ PAJARO 6] para hacerlo.<p><br>
<blockquote>
<table>
<tr><td>_</td><td>PAJARO</td><td>SAME</td><td>12</td><td>13</td><td>;El p&aacute;jaro y el perro est&aacute;n en la misma localidad</td></tr>
<tr><td></td><td></td><td>LET</td><td>12</td><td>8</td><td>;S&oacute;lo en el pabell&oacute;n de m&uacute;sica</td></tr>
<tr><td></td><td></td><td>LET</td><td>5</td><td>3</td><td>;Mu&eacute;velo a la rama, espera 3 frases</td></tr>
<tr><td></td><td></td><td>AT</td><td>5</td><td></td><td>;Est&aacute; el jugador en el pabell&oacute;n de m&uacute;sica?</td></tr>
<tr><td></td><td></td><td>MESSAGE</td><td>13</td><td></td><td>;Dile que el p&aacute;jaro se ha ido</td></tr>
</table>
</blockquote><br>
El n&uacute;mero de cualquier inserci&oacute;n o correcci&oacute;n tiene el valor m&aacute;ximo de 255. O sea,
que no debes de insertar m&aacute;s de 256 entradas con el mismo tipo de palabra (lo cual ser&iacute;a de todos
modos bastante poco manejable), si quieres retener la habilidad de seguir insertando en cualquier parte de la
lista.<p>
El &uacute;ltimo cambio en la tabla de Procesos es insertar un sub-proceso que luego llamaremos desde la
tabla de Respuestas para que se haga cargo de hablar al perro. El mecanismo es muy simple. Si el jugador
incluye una frase "(" ")" en su sentencia de INPUT, entonces el parser guardar&aacute; memoria del lugar donde
est&eacute; y seguir&aacute; descifrando la frase entre comillas.<p>
Hay una acci&oacute;n llamada PARSE que instruye a PAW para que decodifique la cadena de palabras que
el jugador haya tecleado, haciendo entonces la Sentencia L&oacute;gica. Lo l&oacute;gico es hacer esto en un sub-proceso
porque PAW tratar&aacute; de buscar una similitud entre la nueva Sentencia L&oacute;gica y el resto
de la frase.<p>
Entonces comencemos una nueva tabla de Proceso (que debe ser la 5) e insertemos las siguientes entradas:<br><br>
<blockquote>
<table>
<tr><td>*</td><td>*</td><td>PARSE</td><td></td><td>;Convierte una cadena a SL</td></tr>
<tr><td></td><td></td><td>MESSAGE</td><td>16</td><td>;No es una frase v&aacute;lida, as&iacute; que...</td></tr>
<tr><td></td><td></td><td>DONE</td><td></td><td>;El perro no te entiende</td><td></td></tr>
<tr><td></td><td></td><td></td><td></td><td></td><td></td></tr>
<tr><td>SIENTATE</td><td>_</td><td>ZERO</td><td>14</td><td></td><td>;El perro no est&aacute; amarrado?</td></tr>
<tr><td></td><td></td><td>SET</td><td>14</td><td></td><td>;Ahora est&aacute; sentado quieto</td></tr>
<tr><td></td><td></td><td>MESSAGE</td><td>24</td><td></td><td>;D&iacute;selo al jugador (si est&aacute; en el mismo lugar que el perro)</td></tr>
<tr><td></td><td></td><td>DONE</td><td></td><td></td><td></td></tr>
<tr><td></td><td></td><td></td><td></td><td></td><td></td></tr>
<tr><td>VEN</td><td>_</td><td>EQ</td><td>14</td><td>255</td><td>;El perro debe estar sentado</td></tr>
<tr><td></td><td></td><td>CLEAR</td><td>14</td><td></td><td>;Ahora est&aacute; normal</td></tr>
<tr><td></td><td></td><td>MESSAGE</td><td>18</td><td></td><td>;El perro te sigue</td></tr>
<tr><td></td><td></td><td>DONE</td><td></td><td></td><td></td></tr>
<tr><td></td><td></td><td></td><td></td><td></td><td></td></tr>
<tr><td>_</td><td>AQUI</td><td>EQ</td><td>14</td><td>255</td><td></td></tr>
<tr><td></td><td></td><td>CLEAR</td><td>14</td><td></td><td></td></tr>
<tr><td></td><td></td><td>MESSAGE</td><td>18</td><td></td><td></td></tr>
<tr><td></td><td></td><td>DONE</td><td></td><td></td><td></td></tr>
<tr><td></td><td></td><td></td><td></td><td></td><td></td></tr>
<tr><td>_</td><td>_</td><td>MESSAGE</td><td>16</td><td></td><td>;Cualquier otra cosa</td></tr>
</table>
</blockquote><br>
La &uacute;ltima entrada se usa para obviar el vocabulario tan limitado que entiende el perro, haci&eacute;ndole que para cualquier
otra frase mueva la cola, por eso se pone la &uacute;ltima con _ _.<p>
Recordad que PAW va buscando en toda la tabla de Procesos, y si no encuentra una igual a la que busca
caer&aacute; en esta &uacute;ltima entrada de "_ _".<p>
<br>
<b>PARSE</b>: PARSE le permite a PAW continuar buscando condactos si no se encuentra una Sentencia
v&aacute;lida. Hay que tener cuidado aqu&iacute;, puesto que la actual Sentencia L&oacute;gica puede estar
un poco enrevesada (el parser intentar&aacute; sacar alg&uacute;n significado de todos modos) as&iacute; que normalmente
se debe insertar alg&uacute;n mensaje como "Parece no entender" o algo similar, y despu&eacute;s un DONE
para volver a la acci&oacute;n anterior.<p>
Si se forma una Sentencia v&aacute;lida PAW empezar&aacute; a buscar las siguientes entradas por una similar, como
hac&iacute;a en la tabla de Respuestas. PARSE debe ser solamente usada en un sub-rpceso que sea llamado desde la tabla de Respuestas,
puesto que no tiene ning&uacute;n significado en otra tabla.<p>
Date cuenta de como las entradas VEN y AQUI se hacen cargo de una cantidad de frases que el jugador puede
usar despu&eacute;s de que el perro est&eacute; sentado, porque ambas tienen, una delante y otra detr&aacute;s, la palabra comod&iacute;n, o sea,
la raya.<p>
Y por &uacute;ltimo, la entrada "_ _" coge cualquier sentencia que se haya metido en la cadena y para la cual el perro no tenga
ninguna respuesta espec&iacute;fica.<p><br>
Selecciona la tabla de Respuestas, para insertar algunas entradas extras que controlen el habla y el dejar caer
objetos del &aacute;rbol.<p>
La primera de todas es la entrada  que hace que los objetos que se dejen en el &aacute;rbol caigan al suelo.
Esto debe ir entre la entrada que se hace cargo de poner objetos dentro de la bolsa y la entrada normal de
"DEJAR _". Entonces [I PONER _ 1] nos situar&aacute; en esa posici&oacute;n. La entrada es:<br><br>
<blockquote>
<table>
<tr><td>PONER</td><td>_</td><td>AT</td><td>8</td><td></td><td>;Que el jugador est&eacute; en la rama</td></tr>
<tr><td></td><td></td><td>WHATO</td><td></td><td></td><td>;Ya hablaremos de ello</td></tr>
<tr><td></td><td></td><td>LT</td><td>51</td><td>255</td><td>;Es un objeto v&aacute;lido?</td></tr>
<tr><td></td><td></td><td>EQ</td><td>54</td><td>254</td><td>;Es un objeto que llevas encima?</td></tr>
<tr><td></td><td></td><td>MESSAGE</td><td>15</td><td></td><td>;Avisa que est&aacute; al pie del &aacute;rbol</td></tr>
<tr><td></td><td></td><td>PUTO</td><td>7</td><td></td><td>;La pone ah&iacute;</td></tr>
<tr><td></td><td></td><td>DONE</td><td></td><td></td><td></td></tr>
</table>
</blockquote><br>
Esto es un ejemplo de c&oacute;mo se crea una acci&oacute;n autom&aacute;tica, viene a ser lo mismo
que un AUTOG, etc.<p><br>
<b>WHATO</b>: Es una acci&oacute;n que mira el primer nombre de la Sentencia L&oacute;gica actual
en la tabla Objeto-Palabra, y la convierte en el n&uacute;mero de un objeto. Este n&uacute;mero se pone entonces
en la bandera 51. La bandera 51 siempre contiene el n&uacute;mero del &uacute;ltimo objeto que se ha
usado, o el &uacute;ltimo del que PAW tiene una referencia, y siempre que est&eacute; seteada, las banderas
asociadas (n&uacute;meros 54 y 57) tambi&eacute;n se setean.<p>
La bandera 54 lleva la localizaci&oacute;n actual del objeto. Es conveniente que mires el manual t&eacute;cnico
para las banderas 51, 54 y 57.<p>
<br><b>PUTO</b>: Es una acci&oacute;n que cambia de localidad al objeto &uacute;ltimamente tratado,
hacia la localidad que se especifique. O sea, es una acci&oacute;n que cambia el objeto de que se trate hacia
la nueva localidad especificada.<p>
El Mensaje 15 contiene una raya. Siempre que PAW encuentra una raya en el texto (sea mensaje o sea localidad) la
reemplaza con el objeto actual. Es decir, el mensaje se cambia para tener en cuenta el &uacute;ltimo objeto que se
est&eacute; usando.<p>
<br>
Ahora una entrada relativamente simple para que se haga cargo de: PONER LA CORREA AL PERRO.<p><br>
<blockquote>
<table>
<tr><td>PONER</td><td>CORREA</td><td>PREP</td><td>ENCIMA</td><td></td><td>;Para estar seguros de que el jugador teclea eso</td></tr>
<tr><td></td><td></td><td>NOUN2</td><td>PERRO</td><td></td><td></td></tr>
<tr><td></td><td></td><td>CARRIED</td><td>5</td><td></td><td>;Que el jugador tenga la correa</td></tr>
<tr><td></td><td></td><td>SAME</td><td>13</td><td>38</td><td>;Que est&eacute; en la misma localidad que el perro</td></tr>
<tr><td></td><td></td><td>LET</td><td>14</td><td>1</td><td>;Ahora el perro tiene la correa</td></tr>
<tr><td></td><td></td><td>DESTROY</td><td>5</td><td></td><td>;por lo tanto, el jugador no la puede tener</td></tr>
<tr><td></td><td></td><td>MESSAGE</td><td>21</td><td></td><td>;Se le dice</td></tr>
<tr><td></td><td></td><td>DONE</td><td></td><td></td><td></td></tr>
</table>
</blockquote><br>
En las entradas que siguen, introduciremos un nuevo concepto, Se trata de la modificaci&oacute;n de la Sentencia
L&oacute;gica actual.<p>
Nosotros queremos que el juego entienda ambos, ATAR EL PERRO AL BANCO y ATAR LA CORREA AL BANCO
puesto que son la misma cosa. Pero tenemos que correa y perro tienen diferente valor como palabras, as&iacute;
que la entrada ATAR PERRO ir&aacute; primero en la tabla (puesto que su valor es m&aacute;s bajo que
la correa). Por lo tanto, hay que convertir el Nombre en CORREA (55) y permitir que PAW lleve a cabo una entrada que
equivalga a ATAR CORREA: Un sistema similar hay que utilizar para DESATAR.<p>
Esto es bastante importante, y lo utilizar&aacute;s en tus juegos con bastante frecuencia. Hay que poner las entradas:<br><br>
<blockquote>
<table>
<tr><td>ATAR</td><td>PERRO</td><td>LET</td><td>34</td><td>55</td><td>;La bandera 34 es el Nombre de la SL</td></tr>
<tr><td></td><td></td><td></td><td></td><td></td><td></td></tr>
<tr><td>ATAR</td><td>CORREA</td><td>PREP</td><td>A</td><td></td><td></td></tr>
<tr><td></td><td></td><td>NOUN2</td><td>BANCO</td><td></td><td></td></tr>
<tr><td></td><td></td><td>AT</td><td>4</td><td></td><td>;Donde est&aacute; el banco</td></tr>
<tr><td></td><td></td><td>SAME</td><td>13</td><td>38</td><td>;El perro est&aacute; aqu&iacute;</td></tr>
<tr><td></td><td></td><td>EQ</td><td>14</td><td>1</td><td>;Tiene la correa puesta</td></tr>
<tr><td></td><td></td><td>PLUS</td><td>14</td><td>1</td><td>;Ahora atado al banco</td></tr>
<tr><td></td><td></td><td>MESSAGE</td><td>22</td><td></td><td>;Se informa al jugador sobre ello</td></tr>
<tr><td></td><td></td><td>DONE</td><td></td><td></td><td></td></tr>
<tr><td></td><td></td><td></td><td></td><td></td><td></td></tr>
<tr><td>ATAR</td><td>_</td><td>NOTDONE</td><td></td><td></td><td>;Para asegurarse de que no pueda</td></tr>
<tr><td></td><td></td><td></td><td></td><td></td><td></td></tr>
<tr><td>DESATAR</td><td>PERRO</td><td>LET</td><td>34</td><td>55</td><td>;La bandera 34 es el nombre de la SL</td></tr>
<tr><td></td><td></td><td></td><td></td><td></td><td></td></tr>
<tr><td>DESATAR</td><td>CORREA</td><td>AT</td><td>4</td><td></td><td>;Donde est&aacute; el banco</td></tr>
<tr><td></td><td></td><td>EQ</td><td>14</td><td>2</td><td>;Si ya est&aacute; el perro atado</td></tr>
<tr><td></td><td></td><td>CLEAR</td><td>14</td><td></td><td>;La bandera indica que est&aacute; libre</td></tr>
<tr><td></td><td></td><td>MESSAGE</td><td>25</td><td></td><td>;D&iacute;selo al jugador</td></tr>
<tr><td></td><td></td><td>CREATE</td><td>5</td><td></td><td>;Hay que volver a crear la correa</td></tr>
<tr><td></td><td></td><td>GET</td><td>5</td><td></td><td>;D&aacute;rsela al jugador, cogerla</td></tr>
<tr><td></td><td></td><td></td><td></td><td></td><td></td></tr>
<tr><td>DESATAR</td><td>_</td><td>NOTDONE</td><td></td><td></td><td>;Es para asegurarse de que no pueda desatar otra</td></tr>
</table>
</blockquote><br><br>
<b>CREATE</b>: Es una acci&oacute;n que debe ser seguida por un n&uacute;mero de objeto. Ello causa que
el objeto aparezca en la posici&oacute;n donde est&aacute; el jugador.<p><br>
<b>GET</b>: Es una acci&oacute;n que si est&aacute; seguida por un n&uacute;mero de objeto, intenta coger
el objeto especificado.<p>
<br>
Usamos estas acciones en vez de poner el objeto simplemente en 254, porque puede haber problemas debido al peso
o al demasiado n&uacute;mero de objetos que se lleven, y entonces estos problemas deben de producir
informaci&oacute;n.<p>
Finalmente pondermos las entradas que permitan hablar al perro. Hemos tambi&eacute;n incluido algunas entradas necesarias
para que se te permita hablar al p&aacute;jaro, pero que &eacute;l te ignore.
<br><br>
<blockquote>
<table>
<tr><td>DECIR</td><td>PERRO</td><td>SAME</td><td>13</td><td>38</td><td>;Que est&eacute; aqu&iacute</td></tr>
<tr><td></td><td></td><td>PROCESS</td><td>5</td><td></td><td>;Se le manda a esa tabla para que haga el trabajo</td></tr>
<tr><td></td><td></td><td>DONE</td><td></td><td></td><td></td></tr>
<tr><td></td><td></td><td></td><td></td><td></td><td></td></tr>
<tr><td>DECIR</td><td>PAJARO</td><td>SAME</td><td>12</td><td>38</td><td></td></tr>
<tr><td></td><td></td><td>MESSAGE</td><td>8</td><td></td><td></td></tr>
<tr><td></td><td></td><td>DONE</td><td></td><td></td><td></td></tr>
<tr><td></td><td></td><td></td><td></td><td></td><td></td></tr>
<tr><td>DECIR</td><td>_</td><td>MESSAGE</td><td>23</td><td></td><td>;Que pregunte: Qui&eacute;n?</td></tr>
<tr><td></td><td></td><td>DONE</td><td></td><td></td><td></td></tr>
</table>
</blockquote><br>
No ponemos nada para la preposici&oacute;n A, esto permite al jugador recortar su orden si as&iacute;
lo quiere. En l&iacute;neas generales no se debe hacer una comprobaci&oacute;n para una Sentencia L&oacute;gica extendida,
a menos que sea necesario para diferenciar entre dos frases similares.<p>
Como prueba final, ahora debes jugar la aventura intentando atar al perro, hablarle y todas esas chorradas. Por ejemplo,
cuando estemos en el caminoi cerca del banco del parque, con la correa y el perro, intenta PONER LA
CORREA AL PERRO y ATARLO AL BANCO.<p>
Luego para desatarlo digamos:DESATA PERRO<br>
Si estamos arriba del &aacute;rbol con la bolsa, digamos PON TODO EN LA BOLSA y SUELTALA. BAJA y
MIRA DENTRO DE LA BOLSA.<p>
Para hacer que el perro se siente teclea: DECIR AL PERRO "SIENTATE".<p>
Para hacerle volver: DECIR AL PERRO "VEN AQUI".<p>
Funciona?... Malegro.

<p><br>
<center>
<a href="paws9.php">[Anterior]</a> - 
<a href="paws11.php">[Siguiente]</a><br><br>
</center>
<a href="#arriba">[Ir arriba]</a><br>
<a href="../paws.php">[Pgina sobre PAWS]</a><br>

<p>
<?php include "../../../end.php"; ?>

</div>

</body>
</html>

