<DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html>
<head>
 <title>Manual de PAWS</title>
 <link rel="stylesheet" type="text/css"
       href="../../../css/default.css" title="CSS por defecto">
</head>
<body>

<div id="menu">
<?php
  $seccion="spectrum";
  $subseccion="aventura";
  include "../../../menu.php";
?>
</div>


<div id="central">
<a name="arriba"></a>


<h1>Manual de PAWS (XIII)</h1>

<center>
<a href="paws12.php">[Anterior]</a> -
<a href="paws14.php">[Siguiente]</a><br><br>
</center>

<a name="terminal"></a>
<a name="arriba"></a>


<h1>El editor gr&aacute;fico</h1><br>
El sistema usado por PAW para dibujar es el llamado de "L&iacute;nea y Relleno" que es muy eficiente en el
uso de la memoria para el tipo de gr&aacute;ficos que se necesitan en los juegos de aventuras.<p>
La forma como act&uacute;a es, en vez de guardar la imagen que has pintado en la pantalla (screen) como
hacen muchos programas comerciales, lo que hace es que guarda una lista de los comandos que usaste
para dibujarlo.<p>
De esta forma, incluso las im&aacute;genes o los dibujos m&aacute;s complejos consumir&aacute;n solamente
2K de memoria en comparaci&oacute;n a las 7K que lleva una pantalla normal. De hecho, encontrar&aacute;s
que se puede hacer algo incluso con unos 100 bytes, cuando tengas pr&aacute;ctica, por supuesto.<p>
La lista de comandos que se han guardado es lo que se llama una "cadena de dibujo", y hay una cadena de
dibujo para cada localidad que insertes usando la opci&oacute;n de Localidad del men&uacute; principal.
Es decir, PAW te reserva ya un espacio para cada pantalla que t&uacute; has creado cuando has
hecho el texto. Si la dibujas o no ya es cosa tuya. Por lo tanto, si solamente dibujas unas cuantas, las
otras cadenas de dibujo estar&aacute;n vac&iacute;as. <br>
Cada dibujo (y por lo tanto, cada localidad) tiene un color definido de Papel y Tinta. Seleccionando
la opci&oacute;n [D] del men&uacute; se te presentar&aacute; un submen&uacute; en el cual puedes
arreglar estos valores. Usa [P] para ver que ya existe una entrada para las nueve localidades que hemos
creado en el juego de demostraci&oacute;n.<p>
Todas ellas estar&aacute;n de momento marcadas como subrutinas, lo cual dice a PAW dos cosas:<br>
<ol>
<li>No dibujes este gr&aacute;fico cuando describas una localidad</li>
<li>Este es un subdibujo que puede ser usado en otros gr&aacute;ficos</li>
</ol>
La facilidad de tener varios subdibujos es muy similar a la idea que us&aacute;bamos antes con las tablas de subprocesos.
 Luego veremos un ejemplo de ellos.<p>
 Como ejemplo para uso de los gr&aacute;ficos, lo que haremos ser&aacute; dibujar el gr&aacute;fico del Pabell&oacute;n de M&uacute;sica
 como se ver&iacute;a desde la localidad 4 (el camino).<p>
 Como queremos que PAW dibuje el gr&aacute;fico cuando visite la localidad, tendremos que asignarle
 a nuestro gr&aacute;fico un valor para el Papel y la Tinta.<p>
 Usaremos un fondo negro (o sea, papel negro) y una tinta amarilla: teclea [A 4 0 6 ENTER]. Si ahora vuelves
 a usar [P] ver&aacute;s que en la entrada de la localidad 4 dir&aacute;:<br><br>
 <blockquote>
 Localidad 4 Papel: 0 Tinta: 6
 </blockquote><br>
 Si aun no est&aacute;s contento y quieres cambiarlo, tendr&iacute;as que usar la opci&oacute;n de
 corregir (por ejemplo: A 4).<p>
 Seleccionemos la opci&oacute;n G del men&uacute;.<p>
 Los usuarios de 48K se habr&aacute;n sorprendido al ver que no necesitaban cargar otro overlay, esto es porque Caracteres, Colores por Defecto
 y Gr&aacute;ficos est&aacute;n todas en el mismo.<p>
 Si usas la opci&oacute;n Arreglar limpiar&aacute; todos los overlays que PAW tenga
 en memoria y si deseas usar otra opci&oacute;n, excepto CARGAR/GRABAR o Memoria Libre, necesitar&aacute;s cargar
 el overlay que la contiene.<p>
 Pero continuemos con los gr&aacute;ficos.<p>
 Para cada dibujo del juego hay varias opciones que permitir&aacute;n: Arreglar, Imprimir en pantalla, Copiar
 a una impresora, calcular el tamao del dibujo o hacer un volcado (Dump) de la pantalla.<p>
 Como nosotros vamos a hacer el dibujo de la localidad 4, hemos de teclear [A 4 ENTER]. La pantalla
 se limpiar&aacute; dejando solo dos l&iacute;neas de informaci&oacute;n en la zona baja.<p>
 La informaci&oacute;n proporcionada, de izquierda a derecha, es la siguiente:<br>
 <ol>
 <li>L&iacute;nea superior:
 <ul>
 <li>Tinta seleccionada</li>
 <li>Papel seleccionado</li>
 <li>Estado de parpadeo (flash)</li>
 <li>Estado de brillo (bright)</li>
 </ul>
 </li>
 <li>L&iacute;nea inferior:
 <ul>
 <li>Coordenadas x,y de la posici&oacute;n de dibujo</li>
 <li>N&uacute;mero de localidad editada</li>
 </ul>
 </li>
 </ol>
 A veces se da otra informaci&oacute;n adicional y ya la explicaremos en su momento.<p>
 Si miras con atenci&oacute;n, notar&aacute;s un solo pixel parpadenate en la parte inferior derecha, es lo
 que se llama "el punto" y muestra la posici&oacute;n de comienzo para cualquier gr&aacute;fico.<p>
 Tecleando [E], ver&aacute;s que empieza a aparecer una l&iacute;nea cuya parte inicial estar&aacute;
 en el punto y cuyo final podr&aacute;s mover usando las teclas alrededor de la tecla S como muestra
 el siguiente esquema:<br><br>
 <center><img src="./img/img13-1.png"></center><br>
 Si quieres hacer uso de un joystick, puedes insertarlo en el puerto 2 (Plus 2 e Interface 1). Los usuarios de un
 interface tipo Kempston deben apretar [SYMBOL SHIFT] y [J] para activarlo.<p>
 En la l&iacute;nea inferior aparecer&aacute; una J que indica que est&aacute; activo y que el joystick
 controlar&aacute; el final de la l&iacute;nea.<p>
El movimiento es pixel a pixel, pero se puede acelerar a ocho pixels cada vez si se mantiene apretado CAPS
SHIFT al mismo tiempo que las teclas de movimiento o mientras se maneja el joystick.<p>
La l&iacute;nea que se usa para dibujar es del tipo llamado "el&aacute;stico", porque se comporta
como un tenso el&aacute;sitco mientras se mueve por la pantalla; con ello
se consigue una mayor exactitud al posicionarla para el dibujo.<p>
En nuestro juego de ejemplo vamos a utilizar gr&aacute;ficos a media pantalla, por lo que ecesitamos
dejar varias l&iacute;neas libres en la parte inferior de la pantalla para el texto.<p>
Con [SYMBOL SHIFT] m&aacute;s [Y] activamos la Ret&iacute;cula para mostrar las fronteras entre
caracteres.<p>
Ahora hay que mover la <i>l&iacute;nea</i> a X=0, Y=47 y luego mover el "punto" al final de la l&iacute;nea
con [SYMBOL SHIFT] y [P] (Plot) para que el dibujo comience en ese pixel.<p>
Lo siguiente es pasar la <i>l&iacute;nea</i> a X=255, Y=47 usando [A] solo una vez, lo que de paso
sirve para demostrarte que la pantalla no tiene fronteras en los bordes y que al salir por un lado, entrar&aacute;s
por el otro (esta opci&oacute;n, al parecer insignificante, te ahorrar&aacute; mucho tiempo en tus dibujos).<p>
Ahora pasamos a dibujar la l&iacute;nea, lo que se llama "fijarla". Para ello, apretamos [SYMBOL SHIFT] y [L]
(de L&iacute;nea) o usando la opci&oacute;n "fuego" del joystick.<p>
Si se hace un error, se puede borrar una orden previa con DELETE (CAPS SHIFT y 0 en un 48K), lo
cual te llevar&aacute; hasta el inicio del dibujo si as&iacute; lo deseas.<p>
NOTA: Mientras no se especifique lo contrario, todas las &oacute;rdenes de inserci&oacute;n en la cadena
de dibujo (como PLOT o LINE) requieren el uso de SYMBOL SHIFT, por lo cual lo abreviaremos a SS.<p>
NOTA: Todas las coordenadas se dar&aacute;n en forma X, Y. Por ejemplo, 255, 47 en vez de continuar con el engorroso
X=255, Y=47.<p>
Los bordes o  marcos alrededor de los gr&aacute;ficos est&aacute;n de moda, as&iacute; que vamos a poner
uno. Primero hay que mover el final de la l&iacute;nea a 248, 55, y hacer un PLOT en ese punto.<p>
Luego vamos a movernos a 248, 168 y fijar la l&iacute;nea, luego a 7,168 y continuamos fijando la
l&iacute;nea lo mismo que en 7,55 y volvemos a 248, 55. Nos quedar&aacute;, pues, un cuadrado.<p>
Es de notar que hemos ido por la l&iacute;nea que divide las celdas de caracteres. Esto se hace para minimizar
el problema de dos colores por caracter que permite el Spectrum. Es conveniente que leas bien el manual
y veas cual es este problema.<p>
Para hacer el borde mucho m&aacute;s atractivo usaremos la opci&oacute;n SHADE. Movemos el final
de la l&iacute;nea a 248, 53 y apretamos las teclas [SS] + [S] para tener un SHADE. <br>
La parte inferior de la pantalla se cambiar&aacute; y te preguntar&aacute; el n&uacute;mero de dise&ntilde;o
que deseas. De momento tecleamos [12 ENTER], y a continuaci&oacute;n se te pedir&aacute; otro segundo dise&ntilde;o.<p>
Este dise&ntilde;o se pondr&iacute;a encima del primero, a&ntilde;adi&eacute;ndose a &eacute;ste, o sea,
que se pueden mezclar dos dise&ntilde;os para formar uno m&aacute;s complicado.<p>
De momento solamente queremos uno, y teclearemos [12 ENTER] otra vez. Autom&aacute;ticamente
el borde quedar&aacute; con su relleno. Notar&aacute;s que el punto no se ha movido y que la l&iacute;nea
sale desde el mismo sitio desde donde estaba antes del relleno.<p>
<u>CARACTER&Iacute;STICAS DE LA ORDEN SHADE (SOMBREADO):</u><br>
1/ Es un comando muy r&aacute;pido.<p>
2/ Se pueden sombrear incluso &aacute;reas con per&iacute;metro muy dif&iacute;cil.<p>
3/ Se puede colar a trav&eacute;s de cualquier pixel que hayas dejado como "agujero" en tu
dibujo.<p>
4/ El &aacute;rea a sombrear debe estar definida como m&iacute;nimo por una l&iacute;nea de un
solo pixel, o por el borde de la pantalla como en nuestro dibujo.<p>
5/ A veces, si quedan sitios sin rellenar, se puede hacer poniendo el punto de comienzo en la zona
vac&iacute;a.<p>
6/ Hay 16 dise&ntilde;os que se pueden cambiar usando el editor de caracteres (ver Editor de Caracteres).<p>
7/ Si se cambia un dise&ntilde;o, este se cambiar&aacute; en todos los dibujos en los que haya sido usado.
Por eso recomendamos usar la mayor&iacute;a para un uso general y definir unos cuantos para usos
especiales.<p>
8/ Por supuesto, se pueden mezclar diversas combinaciones de dise&ntilde;o.<p>
Ahora vamos, en nuestro dibujo, con el <u>cielo</u> y con la <u>tierra</u>.<p>
Ponemos el color del papel moviendo la l&iacute;nea a 8,56 y apretando [SS] + [A] para una MOVIDA
ABSOLUTA. Esta Movida Absoluta no afecta al pixel como lo hac&iacute;a el PLOT.<p>
Ahora, si tecleamos [SS] + [Y] quitaremos la ret&iacute;cula, pues mientras est&eacute; activa NO se
ven los colores.<p>
Para poner la hierba de color verde, apretaremos [SS] + [C] (para el papel), y como verde es el color 4 teclearemos [4
ENTER] (f&iacute;jate como en la l&iacute;nea inferior de la pantalla el n&uacute;mero de papel
cambia a 4).<p>
Ahora hay que mover la l&iacute;nea a 246,87 y apretar [SS] + [B] (de BLOCK): esto
colorear&aacute; el rect&aacute;ngulo del cual la l&iacute;nea forma la diagonal con el actual color
para el papel y para la tinta.<p>
El azul del cielo: haz [SS] + [A] o una Movida Absoluta hacia 247,88. Seleccionamos ahora papel azul
con [SS] + [C] y [1 ENTER], mov&aacute;monos a 8,167 y hagamos otro BLOCK con [SS] + [B]. Veremos como el
&aacute;rea cuya diagonal estemos se&ntilde;alando se ti&ntilde;e del color que hayamos elegido.<p>
La base del pabell&oacute;n: con ladrillos rojos.<p>
Para evitar problemas de mezcla de colores, debemos hacerla respetando exactamente la frontera de los
dos caracteres; es decir, de 3 de altura por 16 de ancjo. Seleccionamos el papel rojo con [SS] + [C] y
[2 ENTER].<p>
Y la tinta negra con [SS] + [X] y [0 ENTER].<p>
Movemos la l&iacute;nea a 191,72 y hacemos un PLOT con [SS] + [P].<p>
Con  [SS] + [L] (o el bot&oacute;n de fuego del joystick) dibuja lo siguiente:<br><br>
<blockquote>
64,72 64,95 111,95 111,75 144,75 144,95 191,95 191,72</blockquote><br>
Luego, movemos la l&iacute;nea a 189,73 y hacemos un SHADE usando el dise&ntildeo;o 14, por ejemplo:<br>
[SS] +[S], [14 ENTER 14 ENTER] y crearemos el efecto de ladrillos.<p>
Tu dibujo debe verse ahora como el del diagrama 6.<p><br>
<center><table>
<tr><td><img src="./img/img13-2.png"></td></tr>
<tr><td><b>Diagrama 6</b></td></tr>
</table></center>
<br><u>LA ESCALERITA</u>: Mover la l&iacute;nea a 144,78.<p>
Con [SS] + [R] (MOVIDA RELATIVA): Una MOVIDA RELATIVA es la que mueve el punto como PLOT y
como la MOVIDA ABSOLUTA, pero a un pixel que est&aacute; a una distancia fijada del punto actual,
en vez de hacerlo a una posicin absoluta X, Y. Es usado para mantener juntos los grupos de
&oacute;rdenes que dibujan un solo objeto en un gr&aacute;fico. La raz&oacute;n de esto la veremos
en un momento. Fijemos la l&iacute;nea a 112,78.<p>
[SS] + [R] (MOVIDA RELATIVA) para mover a 111,81. Fijemos la l&iacute;nea a 143, 81 y continuamos por los
siguientes grupos de coordenadas:<br><br>
<blockquote>
MOVIDA RELATIVA a 144,84 LINEA a 112,84<br>
MOVIDA RELATIVA a 111,87 LINEA a 143,87<br>
MOVIDA RELATIVA a 144,90 LINEA a 112,90<br>
MOVIDA RELATIVA a 111,93 LINEA a 143,93<br>
</blockquote><br>
Ahora vamos a examinar las facilidades de edici&oacute;n que podemos usar
para corregir errores, aparte del DELETE ya conocido. Como ejemplo, vamos a mover toda la base de
ladrillos que acabamos de crear, dos fronteras de caracteres a la derecha. El borrarla con DELETE toda
entera para volverla a dibujar ser&iacute;a un poco palizas.<p>
Vamos a explicar como PAW guarda la cadena de dibujo. Mientras t&uacute; pintas tu obra maestra,
PAW va aadiendo cada orden a la cadena. El sitio donde la a&ntilde;ade se llama el "puntero de la cadena"
y de momento el puntero de cadena es el final de la cadena.<p>
Es posible para PAW retroceder a trav&eacute;s de las &oacute;rdenes hasta cualquier punto de la cadena. Para ello
se usa el cursor de la cadena (CAPS SHIFT + 8) una sola vez, no hay que preocuparse si desaparece, puesto
que el dibujo todav&iacute;a est&aacute; ah&iacute;. Pero aunque el dibujo est&aacute; todav&iacute;a en
memoria, PAW solo lo pinta hasta donde est&aacute; el puntero, el cual estar&aacute; ahora al comienzo
de la cadena.<p>
El diagrama 7 te facilitar&aacute;la visi&oacute;n de como se situa la cadena en la memoria.<p>
Puedes adelantar al siguiente comando con cursor abajo (CAPS SHIFT + 6) y puedes retrasar el anterior
comando con cursor arriba (CAPS SHIFT + 7). Esto es lo que se llama "Comando Previo", no borra la orden,
s&oacute;lo mueve el puntero una orden hacia atr&aacute;s.<p> <br>
<center><img src="./img/img13-3.png"></center>
<br>
Volviendo con lo nuestro, entonces desde el inicio, CAPS SHIFT + 6 hasta que lleguemos a la orden PLOT, que era,
como recordar&aacute;s, 191,72, con la cual se inici&oacute; la base del Pabell&oacute;n de m&uacute;sica.<p>
Usa DELETE para borrarlo de la cadena y entonces haz un PLOT 207,72
que PAW insertar&aacute; en la cadena de dibujo como si fuera el puntero. Si usamos NEXT, o sea,
(CAPS SHIFT + 6), la l&iacute;nea de la base aparecer&aacute; dibujada.<p>
En vez de usar NEXT cada vez para llegar al final de la cadena hay otra forma mucho m&aacute;s f&aacute;cil:
cuando est&eacute;s al principio de una cadena muy larga si tecleas ENTER terminar&aacute; la edici&oacute;n
y te llevar&aacute; al sub-men&uacute;. Entonces teclea [A 4 ENTER] para corregir el dibujo otra vez,
y ya tendras el puntero al final de la cadena.<p>
<u>Es importante que te des cuentea de que la base entera se mueve como una sola unidad, porque antes
usamos una MOVIDA RELATIVA, cuando la pintamos originalmente.<p></u>
<u>LA BALAUSTRADA</u><br>
Seleccionamos tinta blanca [SS] + [X] [7 ENTER], y papel <u>transparente</u> (es un color especial que
significa no modificar el color), lo hacemos con [SS] + [C], [8 ENTER]. Luego:<br>
<blockquote>
<table cellspacing="10">
<tr><td>PLOT 206,96</td><td>LINEA 206, 109</td><td>LINEA 162, 109</td><td>LINEA 162,96</td></tr>
</table>
</blockquote>
mueve ahora la l&iacute;nea a 163,97 y haz un SHADE con el
dise&ntilde;o 15 (el que hab&iacute;s dise&ntilde;ado en la secci&oacute;n del Editor de Caracteres),
se hace con [SS] + [S], [15 ENTER 15 ENTER].
<blockquote>
<table cellspacing="10">
<tr><td>PLOT 125,96</td><td>LINEA 125,109</td><td>LINEA 81,109</td><td>LINEA 81,96</td></tr>
</table></blockquote>
mueve la l&iacute;nea ahora a 82,97 y utiliza el dise&ntilde;oo de SHADE n&uacute;mero 15 otra vez.<p>
Vamos ahora con los palos del pabell&oacute;n de m&uacute;sica:<br>
<blockquote><table cellspacing="10">
<tr><td>PLOT 103,96</td><td>LINEA 103,136</td><td>LINEA 106,136</td><td>LINEA 106,96</td></tr>
</table></blockquote>
mueve la l&iacute;nea a 104,121 y con [SS] y [F] accedemos al comando FILL: &eacute;ste llena un &aacute;rea
previamente definida completamente con pixels seteados en una forma muy similar a SHADE,<br>
<blockquote><table cellspacing="10">
<tr><td>MOVIDA RELATIVA 184,96</td><td>LINEA 184,136</td<<td>LINEA 181,136</td><td>LINEA 181,96</td></tr>
</table></blockquote>
mueve la l&iacute;nea a 183,122 y haz otro FILL con [SS] + [F].<p>
Veamos ahora el techo del pabell&oacute;n:<br>
<blockquote><table cellspacing="10">
<tr><td>MOVIDA RELATIVA 207,143</td><td>LINEA 206,140</td><td>LINEA 202,136</td><td>LINEA 86,136</td></tr>
<tr><td>LINEA 83,139</td><td>LIENA 80,143</td><td>LINEA 207,143</td><td></td></tr>
</table></blockquote>
mueve la l&iacute;nea a 205,141  y haz un SHADE con el dise&ntilde;o 15.<p>
<blockquote><table cellspacing="10">
<tr><td>MOVIDA RELATIVA 144,166</td><td>LINEA 200,139</td></tr>
<tr><td>MOVIDA RELATIVA 65,139</td><td>LINEA 144,166</td></tr>
</table></blockquote>
mueve la l&iacute;nea a 144, 164 y haz un FILL.<p><br>
<u>Creando un efecto de volumen en el pabell&oacute;n de m&uacute;sica:</u><br>
Selecciona OVER con las teclas [SS] + [O], aparecer&aacute; una letra O en la l&iacute;nea de estado
para indicar que el OVER est&aacute; activado.<p>
Normalmente cada PLOT y LINEA lo que hace es setear los pixels a los cuales afecta, pero esos mismos
comandos, si se insertan mientras la acci&oacute;n OVER est&aacute; activada, lo que hacen es
setear todos los pixels seteados y resetear todos los pixels seteados. Es decir, encienden los apagados
y apagan los encendidos.<p>
Se parece mucho a la acci&oacute;n que hac&iacute;a SPACE cuando mir&aacute;bamos el Editor
de Caracteres, Es importante recalcar que el estado de OVER (y el Inverso que veremos m&aacute;s
adelante) est&aacute;n codificados como parte de la orden; para obtener el efecto, tienes que insertar
la orden <u>mientras est&aacute; activo</u>, no puedes cambiar un PLOT o LINEA insertado previamente
sin haberlo borrado con anterioridad.<p>
OVER se cancela con START (CAPS SHIFT + 8), PREVIUS (CAPS SHIFT + 7) y DELETE.<p>
Ahora con el OVER seleccionado haz lo siguiente:<br>
<blockquote><table cellspacing="10">
<tr><td>LINEA 115, 140</td><td>MOVIDA RELATIVA 144,166</td><td>LINEA 171,140</td></tr>
</table></blockquote>
y despu&eacute;s [SS] + [O] para quitar el OVER otra vez. Debes de tener dos l&iacute;neas dibujadas
con pixels en parte seteados y en parte reseteados.<p>
El &uacute;ltimo toque del pabell&oacute;n:<br>
<blockquote><table cellspacing="10">
<tr><td>MOVIDA RELATIVA 142,136</td><td>LINEA 142,96</td><td>LINEA 145,96</td><td>LINEA 145,135</td></tr>
</table></blockquote>
mueve la l&iacute;nea a 143,133 y haz un FILL.<p>
La parte trasera de la balaustrada debe ser un poco m&aacute;s peque&ntilde;a:<br>
<blockquote><table cellspacing="5">
<tr><td>MOVIDA RELATIVA 125,107</td><td>LINEA 161,107</td></tr>
<tr><td>MOVIDA RELATIVA 162,96</td><td>LINEA 126,96</td></tr>
</table></blockquote>
mueve la l&iacute;nea a 128,98 y haz un SHADE con el dise&ntilde;o 15. Mueve la l&iacute;nea a
150,98 y haz un SHADE con el dise&ntilde;o 15 otra vez.<p>
Para que quede mejor, deber&iacute;amos hacer destavar el palo central removiendo una l&iacute;nea
de pixels a cada lado. Hagamos [SS] + [I] (INVERSE) y la letra I aparecer&aacute; en la l&iacute;nea de estado
para indicarte que el INVERSE est&aacute; activado.<p>
INVERSE hace que cualquier PLOT y LINEA reseteen o apaquen los pixels afectados en vez de
setearlos o encenderlos, por lo tanto:<br>
<blockquote><table cellspacing="10">
<tr><td>MOVIDA RELATIVA 141,95</td><td>LINEA 141,107</td></tr>
<tr><td>MOVIDA RELATIVA 146,108</td><td>LINEA 146,96</td></tr>
</table></blockquote>
ahora quita el INVERSE con [SS] + [I].<p>
<u>La cerca</u><br>
Vamos a usar una t&eacute;cnica importante de desdibujar el per&iacute;metro de un dise&ntilde;o de sombreado
(SHADE):<br>
<blockquote>
Tinta negra [SS] + [X], [0 ENTER]<br><br>
<table cellspacing="10">
<tr><td>PLOT 8,104</td><td>LINEA 79,104</td><td>LINEA 79,88</td><td>LINEA 8,88</td></tr>
<tr><td>PLOT 247,88</td><td>LINEA 208,88</td><td>LINEA 208,104</td><td>LINEA 247,104</td></tr>
</table></blockquote>
Usamos el dise&ntilde;o de SHADE n&uacute;mero 7 en 246,102 y 11,102.<p>
Vamos a desdibujar la aprte de arriba de la cerca para crear algunas peque&ntilde;as puntas: [SS] +
[I] (INVERSE).<p>
<blockquote><table cellspacing="10">
<tr><td>PLOT 246,104</td><td>LINEA 208,104</td><td>PLOT 79,104</td><td>LINEA 8,104</td></tr>
</table></blockquote>
Luego quita el INVERSE.<p>
Para terminar el efecto:<br>
<blockquote><table cellspacing="10">
<tr><td>PLOT 8,101</td><td>LINEA 79,101</td><td>PLOT 208,101</td><td>LINEA 247,101</td></tr>
</table></blockquote>
Vamos a a&ntilde;adir ahora unos matorrales de hierba usando la sub-rutina que mencionamos anteriormente.
Esto nos economiza&aacute; memoria y tiempo. Con ENTER vamos al submen&uacute;. Como la localidad 0
es la pantalla de t&iacute;tulo vamos a usarla en nuestro juego de demostraci&oacute;n para que su cadena de
dibujo contenga nuestros matorrales de hierba.<p>
Usemos [A 0 ENTER] para corregir el dibujo de la localidad 0. Nos damos cuenta de que el n&uacute;mero
est&aacute;a seguido por la letra S, que indica que es una sub-rutina (no se pintar&aacute;).<p>
Pinta el hierbajo con un PLOT 72,72 y ahora pongamos l&iacute;neas entre los siguientes puntos:<br>
<blockquote><table cellspacing="10">
<tr><td>65,85</td><td>77,73</td><td>74,89</td><td>81,73</td><td>79,94</td><td>87,72</td></tr>
<tr><td>87,94</td><td>92,70</td><td>94,86</td><td>95,70</td><td>99,79</td><td>98,69</td></tr>
</table></blockquote>
Volvamos al comienzo de la cadena con (CAPS SHIFT + 8) y usemos el comando NEXT (CAPS SHIFT + 6)
para ir hasta justo despu&eacute;s del PLOT. Usemos DELETE para quitarlo.<p>
OJO: esta acci&oacute;n extra&ntilde;a significa que ahora la primera l&iacute;nea est&aacute; en 0,0
y nos permite colocar el dibujo con exactitud.<p>
OJO: si tratas de corregir el dibujo otra vez (AMEND) saldr&aacute; el mensaje "Out of range" que
significa fuera de l&iacute;mites, porque PAW no puede dibujar "fuera de la pantalla". El puntero de cadena
deber&aacute; estar situado exactamente antes de la primera orden LINEA. As&iacute; que insertemos el
PLOT otra vez mientras editas la cadena, borr&aacute;ndolo de nuevo al final.<p>
Corrige el dibujo 4 de nuevo [A 4 ENTER] y hagamos un PLOT en el punto 217,69. Ahora con [SS] y [G]
activaremos un bucle GOSUB y te pedir&aacute; el n&uacute;mero de la localidad que vas a usar;
teclea [0 ENTER] para usar nuestro hierbajo que hemos definido en esta localidad.<p>
Lo siguiente que se te pedir&aacute; ser&aacute; la escala en que vas a dibujarlo; esta escala va
de 8 en 8 (o sea, en octavos) desde su tama&ntilde;o original. Por ejemplo, si tecleas [4 ENTER] ser&aacute; 4/8
(4 octavos) igual a la mitad.<p>
<blockquote><table cellspacing="10">
<tr><td>PLOT 21,58</td><td>GOSUB 0 escala 5</td></tr>
<tr><td>PLOT 60,74</td><td>GOSUB 0 escala 3</td></tr>
<tr><td>PLOT 103,61</td><td>GOSUB 0 escala 4</td></tr>
</table></blockquote>
Y para demostrar errores:<br>
<blockquote><table cellspacing="10">
<tr><td>PLOT 128,170</td><td>GOSUB 0 escala 0</td></tr>
</table></blockquote>
Supongo que sabr&aacute;s que escala 0 significa tama&ntilde;o completo (no 0 octavos). El error que se
ha generado ha dejado el puntero de la cadena antes del comando que caus&oacute; el error: en este caso
el GOSUB.<p>
Parecer&iacute;a que no hay forma de borrar esto sin continuar haciendo PLOTS cada vez m&aacute;s
lejos. Pero de hecho, [GRAPH] que es (CAPS SHIFT + 9 en un 48K) borrar&aacute;el <u>siguiente</u> o
pr&oacute;ximo comando y podr&aacute;s borrar tambi&eacute;n el PLT de esta manera.<p>
A tener en cuenta es que, al final de una edici&oacute;n, es posible dejarse &oacute;rdenes por encima del
puntero de cadena que sean in&uacute;tiles. Puedes borrarlas todas
usando DELETE NEXT (GRAPH) por un tiempo.<p>
Ahora vuelve al men&uacutE; principal y selecciona la tabla de Respuestas (los 48K deber&aacute;n cargar un overlay).
Corrige la entrada * * para que ponga MODE 3 3 LINEA 16 antes de GOTO 2.<p>
La acci&oacute;n MODE 3 selecciona uno de los modos de operar la pantalla. En este caso quedar&aacute;
un &aacute;rea de gr&aacute;fico fijo, ning&uacute;n texto la mueve; el segundo 3 le informa a PAW que no debe
cambiar el color del borde y que debe imprimir "CONT.." cuando la pantalla est&eacute; llena de texto.<p>
LINEA 16 le dice a PAW d&oacute;nde va a empezar la primera l&iacute;nea de texto.<p>
Finalmente usamos TEST para probar la aventura (de nuevo lo s de 48K deben de cargar un OVERLAY) para
verla en acci&oacute;n.<p>
El dibujo solamente ser&aacute; pintadola primera vez que visites la localidad, pero no en visitas siguientes. Esto es
los que se llama el modo normal para gr&aacute;ficos. Es posible de todos modos seleccionar ON y OFF, siendo ON la opci&oacute;n
para <u>siempre</u> poner los gr&aacute;ficos y OFF <u>nunca</u> poner los gr&aacute;ficos.<p>
Se seleccionan con
<blockquote>
<table>
PICS NORM<br>
PICS ON<br>
PICS OFF<br>
</table></blockquote>
Esas &oacute;rdenes no fueron explicadas cuando hablamos de la tabla de Respuestas, pero est&aacute;n
todas en el manual t&eacute;cnico (que tambi&eacute;n habr&aacute;s de leer, je, je).<p>
Debes decidir si permites al jugador cambiar entre las opciones o no, y forzarle a usar un solo m&eacute;todo desde el
comienzo.

<p><br>
<center>
<a href="paws12.php">[Anterior]</a> - 
<a href="paws14.php">[Siguiente]</a><br><br>
</center>
<a href="#arriba">[Ir arriba]</a><br>
<a href="../paws.php">[Pgina sobre PAWS]</a><br>

<p>
<?php include "../../../end.php"; ?>

</div>

</body>
</html>

