<DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html>
<head>
 <title>Manual de PAWS</title>
 <link rel="stylesheet" type="text/css"
       href="../../../css/default.css" title="CSS por defecto">
</head>
<body>

<div id="menu">
<?php
  $seccion="spectrum";
  $subseccion="aventura";
  include "../../../menu.php";
?>
</div>


<div id="central">
<a name="arriba"></a>


<h1>Manual de PAWS (VIII)</h1>

<center>
<a href="paws7.php">[Anterior]</a> -
<a href="paws9.php">[Siguiente]</a><br><br>
</center>

<a name="terminal"></a>
<a name="arriba"></a>

<h1>Diagn&oacute;stico</h1>
Con T del men&uacute; principal se selecciona la opci&oacute;n de probar el juego, o sea, de hacer un test de la aventura.<p>
Primero te pregunta si quieres o no quieres diagn&oacute;stico; si tecleas "si" aparecer&aacute; el t&iacute;tulo y la introducci&oacute;n, y en la parte de abajo se pide un INPUT al jugador.<p>
El que hayas contestado que quieres diagn&oacute;stico no tiene efecto aparente todav&iacute;a, pero si tecleas ENTER <u>antes</u> de cualquier otra cosa, el cursor desaparece y aparecer&aacute; una l&iacute;nea parecida a:<br><br>
<blockquote>
Flag 38 = 0 ?
</blockquote><br>
Con flag se refiere PAW a una bandera, en este caso la 38, que es la que lleva el n&uacute;mero de la localidad presente.<p>
PAW contiene 256 de estas banderas, y en cada una se puede situar un n&uacute;merode 0 a 255. Se usan para indicar el estado de alguna parte del juego.<p>
Por ejemplo, si decides que la bandera 11 se ponga a 1 cuando la puerta del parque est&eacute; cerrada, y haga un clear a 0 cuando est&eacute; abierta, esto servir&aacute; de marcadaor para que luego puedas dejar pasar  o no al jugador cuando teclee ENTER.<p>
Es decir, si la bandera estuviera a 0 podr&iacute;a pasar, y si la bandera estuviera a 1 le dar&iacute;as el informe de que la puerta est&aacute; cerrada.<p>
PAW tiene para su uso espec&iacute;fico varias banderas (de la 0 a la 10 y de la 29 a la 59). Por eso, si el valor que aparece al lado de la bandera 38 es igual a 0, pAW sabe que tu localidad actual es 0 en este caso.<p>
Para ver c&oacute;mo funciona esto, teclea ENTER de nuevo (con ENTER cambiamos el uso entre la ioci&oacute;n diagn&oacute;stico o continuar con el INPUT si no has tecleado ning&uacute;n otro comando) y v&aacute;monos hacia el principio del juego usando la palabra NORTE o cualquier otra direcci&oacute;n que hayas puesto.<p>
De nuevo, antes que cualquier otra cosa teclea ENTER y ver&aacute;s que la bandera a cambiado a 2; esto es, por supuesto, porque est&aacute;s en la localidad 2.<p><br>
<blockquote>
Flag 38 = 2 ?
</blockquote><br>
Puedes mirar a los valores de cualquier otra bander tecleando su n&uacute;mero antes de apretar el ENTER; por ejemplo: 100 ENTER y entonces puedes ver el valor de esa bandera.<p><br>
<blockquote>
Flag 100 = 0 ?
</blockquote><br>
Pero hay otra opci&oacutE;n mucho m&aacute;s potente que te deja poner el valor que quieres que tenga una bandera. Ello se hace poniendo el signo = frente al n&uacute;mero. Por ejemplo, si en este momento tecleas = 10 ENTER ver&aacute;s que la bandera 100 se ha hecho = a 10.<p><br>
<blockquote>
Flag 100 = 10 ?
</blockquote><br>
La bandera 100 no hace nada en este juego y su valor no es importante, pero si te pones a practicar por tu cuenta ten cuidado de NO cambiar los valores de ninguna otra bandera de momento, porque te puedes tropezar con alguna otra bandera que S&Iacute; sea importante, y el juego te haga un enredo. Vuelve a la l&iacute;nea de INPUT pulsando ENTER  y veamos que m&aacute;s puede hacer PAW.<p>
Ahora si que seremos capaces de manipular los objetos en el juego. De momento la bolsa estar&aacute; en la parada del autob&uacute;s. Con nosotros llevaremos el emparedado, la manzana, una antorcha apagada, y el anorak puesto.<p>
Usa el diagn&oacute;stico para ver el valor de la bandera 1 (se hace con ENTER 1 ENTER), y vemos que tiene el valor de 3, que es el n&uacute;mero de objetos que se llevan en las manos, pero no puestos encima. Volvamos a la l&iacute;nea de INPUT y tecleamos "coger bolsa" y PAW imprimir&aacute; el mensaje "Ahora cojo la bolsa".<p>
Es lo que se llama AUTO-REPORTING (informe autom&aacute;tico de cualquier acci&oacute;n que hayas hecho).<p>
Esta &uacute;ltima orden ha hecho que la posici&oacute;n de la bolsa haya cambiado de la localidad 2 que era la parada del autob&uacute;s a la localidad 254 (que es una localidad especial para los objetos que peuden ser llevados pero no puestos).<p>
F&iacute;jate que no hay ning&uacute;n cambio en la tabla donde se localizan los objetos al comienzo, sino que lo que ha cambiado es la copia que se ha hecho de la base de datos cuando se empieza el juego.<p>
Si ahora miras el valor de la bandera 1 (f&iacute;jate tambi&eacute;n como cuando se selecciona diagn&oacute;stico estar&aacute; en uso la &uacute;ltima bandera que hayas mirado) ver&aacute;s que su valor ha aumentado a 4.<p>
Ahora puedes "quitar anorak" y recibir&aacute;s el mensaje "No puedo quitarme el anorak, mis manos est&aacute;n llenas". Esto es porque PAW inicialmente (si tu no le has dicho lo contrario) solo permite al jugador llevar cuatro objetos al mismo tiempo, y en algunos casos esta limitaci&oacute;n puede impedirle al jugador quitarse vestido, etc. (de hecho, quitarse una prenda es cambiar la posici&oacute;n de ese objeto de la localidad 253, que es llevado encima, a la localidad 254 que es llevado en la mano).<p>
Si, por ejemplo, dejamos la bolsa primero y tecleamos "quitar anorak" veremos que s&iacute; se puede. Si miras otra vez la bandera 1 te dar&aacute;s cuenta de que todav&iacute;a tiene el n&uacutE;mero 4; esto es porque al quitarte el anorak has aumentado el n&uacute;mero de objetos que llevabas en tus manos.<p>
Ahora como prueba teclea las siguientes &oacute;rdenes y f&iacute;jate que hace cada una (usando las banderas):<br><br>
<blockquote>
Coger Bolsa<br>
Quitar Anorak<br>
Poner Anorak<br>
Coger Manzana<br>
Coger Billete de autobus
</blockquote><br>
Hay que dase cuenta de que todas las respuestas, excepto la de la &uacute;ltima orden, mencionan los objetos por su nombre; esto es porque estaban todos a la vista y por lo tanto el jugador sab&iacute;a que exist&iacute;an (estaban en su propia localidad). Pero para un jugador que no conociera el juego, el billete todav&iacute;a no existir&iacute;A, y si se teclea "coger billete" ya en la respuesta lo mencionamos por su nombre, le estar&iacute;mos dando una pista muy importante. Y es que el PAW es muy cuco.<p>
Si tratas de poner cualquier cosa dentro de la bolsa descubrir&aacute;s que PAW lo que hace es dejar caer los objetos al suelo; esto es porque no le hemos dicho a PAW todav&iacute;a <u>que cosas</u> pueden ser puestas dentro de la bolsa. Solamente le hemos dicho de momento que es un contenedor, en el pr&oacute;ximo cap&iacute;tulo trataremos de este tema.<p>
Finalmente encontramos un terrible "error" en nuestro juego: si tecleamos "coger la puerta", se nos dar&aacute; la respuesta de "No hay ninguna de esas aqu&iacute;" o "No est&aacute; eso aqu&iacute;". No deber&iacute;a decir eso, porque en la descripci&oacute;n hemos dicho que hay una puerta.<p>
Este es un problema muy frecuente, y ocurre porque le hemos dicho ha PAW que hay una manzana, un emparedado, etc. pero no lo hemos dicho que existe una puerta, y si usas coger o dejar, etc. con cualquier palabra que no est&eacute; en el vocabulario entonces PAW asume que es un objeto que "no est&aacute; aqu&iacute;". Sin embargo, una vez que esa palabra entre en el vocabulario, PAW sabr&aacute; que no es un objeto (siempre que no haya una entrada para esa palabra en la tabal de relaci&oacute;n objeto-palabras) y dar&aacute; la respesto "no puedo hacer eso" que es la correcta.<p>
As&iacute; que volvemos al men&uacute; principal tecleando FIN, ENTER, SI, ENTER, NO, ENTER y seleccionaremos de nuevo la opci&oacute;n de Vocabulario V.<p>
Pongamos todos los nombres de las cosas que hayamos usado en la descripci&oacute;n, aunque no sean objetos, tales como:<br>
<blockquote>
<table cellspacing=10>
<tr><td>Puerta</td><td>57</td><td>Camino</td><td>60</td><td>Arbol</td><td>63</td></tr>
<tr><td>Reja</td><td>58</td><td>Banco</td><td>61</td><td>Rama</td><td>63</td></tr>
<tr><td>Hierba</td><td>59</td><td>Estanque</td><td>62</td><td>Hoja</td><td>63</td></tr>
</table>
</blockquote><br>
Es importante que Arbol, Rama y Hoja reciban el mismo n&uacute;mero, porque no intentamos que sean manipulables, sino que solamente las entienda el PARSER. Si fueran manipulables, tendr&iacute;amos que darles n&uacute;meros diferentes. Esto es una consideraci&oacute;n <u>importante</u> de dise&ntilde;o.<p>
Ahora puede ser el momento de hacer otro test del juego para ver que la orden "coger puerta" produzca una respuesta correcta.<p>
De momento hemos creado las localidades, las hemos conectado entre s&iacute;, hemos creado y descrito los objetos, les hemos asignado una palabra desde el vocabulario, un punto de comienzo en le juego, un peso relativo, si eran llevables o quitables, y si eran contenedores.<p>
El pr&oacute;simo cap&iacute;tulo tratar&aacute; de c&oacute;no se crean algunos problemas y otros personajes para hacer que el juego sea m&aacute;s interesante.<p><br>

<a href="files/air8-1.tar.gz">Demostraci&oacute;n AIR</a><br><br>
<a href="files/tzx8.tzx">Base de datos hasta el momento (nombre 'prueba 5')</a>

<p><br>
<center>
<a href="paws7.php">[Anterior]</a> - 
<a href="paws9.php">[Siguiente]</a><br><br>
</center>
<a href="#arriba">[Ir arriba]</a><br>
<a href="../paws.php">[Pgina sobre PAWS]</a><br>

<p>
<?php include "../../../end.php"; ?>

</div>

</body>
</html>

