<DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html>
<head>
 <title>Manual de PAWS</title>
 <link rel="stylesheet" type="text/css"
       href="../../../css/default.css" title="CSS por defecto">
</head>
<body>

<div id="menu">
<?php
  $seccion="spectrum";
  $subseccion="aventura";
  include "../../../menu.php";
?>
</div>


<div id="central">
<a name="arriba"></a>


<h1>Manual de PAWS (XIV)</h1>

<center>
<a href="paws13.php">[Anterior]</a> -
[Siguiente]<br><br>
</center>

<a name="terminal"></a>
<a name="arriba"></a>


<h1>Notas adicionales para la &uacute;ltima versi&oacute;n del PAW</h1><br>
La versi&oacute;n castellana de PAW se corresponde con la versi&oacute;n A18 inglesa, siendo por tanto la m&aacute;s
avanzada de las existentes.<p>
Las diferencias con respecto a todo lo que se ha explicado en estos densos y sapient&iacute;simos manuales son:
<h2>Overlays para el usuario</h2>
La &uacute;ltima versi&oacute;n de PAW contiene una caracter&iacute;stica muy importante que permite, y de hecho facilita,
la incorporaci&oacute;n dentro del sistema de cualquier rutina o utilidad hecha por separado: son los overlays del usuario.<p>
Estos a&ntilde;adidos deben estar escritos en Assembler y pueden tener hasta 5K de longitud.<p>
Para ellos se ha a&ntilde;adido en el men&uacute; principal la opci&oacute;n Z, que te pregunta el nombre de la base
de datos a cargar.<p>
Puedes elegir entre cualquier letra (A - Z) y PAW empezar&aacute; a buscar en el "perif&eacute;rico escogido" por una base
de datos con esa extensi&oacute;n.<p>
<h2>Perif&eacute;rico escogido (Current Device)</h2>
PAW ahora te preguntar&aacute; siempre en que perif&eacute;rico vas a Salvar/Cargar tu base de datos. Puedes
hacerlo en Disco, Cassette o Microdrive.<p>
<h2>Drivers de impresoras</h2>
El Driver de Impresora queda ahora limitado a 48 bytes en la direcci&oacute;n 29587 (PRTADD). Aunque la memoria ha
quedado sensiblemente reducida, se ha hecho para poder dar m&aacute;s facilidades extras.<p>
<h2>El parser</h2>
En esta versi&oacute;n se han hecho algunos sutiles cambios en la cadena que maneja el PARSER.<p>
Casi todos est&aacute;n encaminados a facilitar e implementar el manejo de los PSI. Pero, aunque no los uses, debes
saber que existen, pues pueden afectar algunas partes del juego.<p>
1-El condacto PARSE, mantiene ahora la "posici&oacute;n actual" dentro de una cadena en la SL que est&aacute; siendo
usada.<p>
Por lo tanto, un segundo condacto PARSE, continuar&aacute; a partir de esa posici&oacute;n.<p>
En las versiones anteriores, un segundo condacto PARSE, hubiera dado como respuesta la misma SL que el primero.<p>
Por lo tanto la frase ...Dile al Archivero "coge la espada y mata al drag&oacute;n" es aceptada y ejecutada en cada
una de sus acciones.<p>
2-La acci&oacute;n PARSE, no afectar&aacute; al indicador que marca si la "l&iacute;nea de comando" est&aacute; vac&iacute;a o llena,
que estaba controlado por la acci&oacute;n NEWTEXT.<p>
Esto significa que una orden del tipo...Decir al Archivero "Coge la llave", ir al Norte....ser&aacute; en esta versi&oacute;n
ejecutada correctamente, es decir, primero lo que has dicho al PSI y luego tu acci&oacute;n de irte al Norte.<p>
En versiones anteriores, el marcador controlado por NEWTEXT se hubiera seteado autom&aacute;ticamente, pero esto se
ha cambiado para permitir, en caso de que haua m&uacute;ltiples acciones PARSE, encontrar el &uacute;ltimo comando
de una cadena sin que la bandera se setee.<p>
Por lo tanto, en todos tus juegos previos debes a&ntilde;adir una acci&oacute;n NEWTEXT justo despu&eacute;s de una
orden PARSE (que es el exacto lugar donde el Proceso ir&aacute; si no encuentra una sentencia v&aacute;lida en la
cadena), si quieres manetener la compatibilidad.<p>
3-El verbo y Adverbio actuales no se borran (las banderas 33 y 36 permanecen seteadas) cuando se ejecuta la acci&oacute;n PARSE
en una cadena. Esto significa, que si un Verbo (o un Nombre Convertible en Verbo), es omitido de la primera frase en
la cadena, el Verbo usado ser&aacute; el de la frase que inici&oacute; o dispar&oacute; la acci&oacute;n PARSE
(usualmente un ...Decir a...).<p>
Esto es un cambio menor, pero significa que el Verbo Actual se mantiene cuando la cadena sufre un PARSEado
m&uacute;ltiple.<p>
<h2>Un bandera m&aacute;s</h2>
Recuerdas que te insisitmos mucho en que respetara las banderas hasta la 60, porque se usar&iacute;an en
futuras expansiones?<br>
Pues el caso ha llegado con esta nueva versi&oacute;n.<p>
Nos congratulamos en anunciar que la bandera 58 ha alcanzado el estatus de "Bandera del sistema".<p>
Si la seteas a 128 (es decir, el bit 7), PAW empezar&aacute; a buscar pareja para palabras en la tabla de Procesos,
cosa que antes, como recordareis, solo hac&iacute;a en la tabla de respuestas.<p>
Esto facilita lo visto anteriormente en los PARSE m&uacute;ltiples, permitiendo acciones para un PSI en la
tabla de Procesos 2. Estamos seguros, de que con tu habilidad habitual, le encontrar&aacute;s otros usos.<p>
Pero este efecto se cancela la pr&oacute;xima vez que el Proceso 1 y el Proceso 2 sean ejecutados, porque PAW le resta
a la bandera los 128 que le deb&iacute;a.<p>
Esto es para asegurar que los Procesos 1 y 2 actuen con normalidad hasta que se les ordene de una manera espec&iacute;fica
(con la bandera 58 en 128) que se comporten especialmente.<p>
Suponemos que deducir&aacute;s h&aacute;bilmente que si pones 58 a 0, el efecto se anula.<p>
A medida que vayamos introduciendo mejoras recibir&aacute;s pronta documentaci&oacute;n sobre ellas.<p>
<h2>Final del camino</h2>
Esperamos que el manual anterior te haya dado una peque&ntilde;a idea de las facilidades que ofrece PAW y de lo complejo
que es.<p>
Ahora te toca a t&iacute; profundizar m&aacute;s en &eacute;l por medio del uso.<p>
La Gu&iacute;a T&eacute;cnica te dar&aacute; una especificaci&oacute;n exacta de todo lo que contiene PAW, adem&aacute;s de
varios ensayos sobre otros temas que te ser&aacute;n de mucha utilidad a la hora de crear tus propios juegos.<p>
En la cinta, adem&aacute;s de PAW y todos sus Overlays, encontrar&aacute;s una base de datos llamada Start que
te dar&aacute; un comienzo r&aacute;pido.<p>
En la otra cara est&aacute;n los 22 sets de caracteres y al final encontrar&aacute;s una magnifica "Demo" que debe ser
cargada usando la opci&oacute;n J del men&uacute; principal (despu&eacute;s de haber salvado tu base de datos,
por supuesto).<p>
Ver&aacute;s en esta Demo ejemplos de Vocabulario, manejo de tablas, complicados dibujos con subrutinas, manejo de objetos
(lleno y vac&iacute;o), e incluso un simp&aacute;tico PSI al cual deber&aacute;s aprender a hablar entre comillas
(decir "como te llmas").<p>
Estudia a fondo este breve ejemplo tomado nada menos que de la AVENTURA ORIGINAL, te dar&aacute; muchas ideas de c&oacute;mo
debes planear tu juego.<p>
<em>Andr&eacute;s R. Samudio</em>.

<p><br>
<center>
<a href="paws13.php">[Anterior]</a> - 
[Siguiente]<br><br>
</center>
<a href="#arriba">[Ir arriba]</a><br>
<a href="../paws.php">[Pgina sobre PAWS]</a><br>

<p>
<?php include "../../../end.php"; ?>

</div>

</body>
</html>

