<DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html>
<head>
 <title>Manual de PAWS</title>
 <link rel="stylesheet" type="text/css"
       href="../../../css/default.css" title="CSS por defecto">
</head>
<body>

<div id="menu">
<?php
  $seccion="spectrum";
  $subseccion="aventura";
  include "../../../menu.php";
?>
</div>


<div id="central">
<a name="arriba"></a>


<h1>Manual de PAWS (V)</h1>

<center>
<a href="paws4.php">[Anterior]</a> -
<a href="paws6.php">[Siguiente]</a><br><br>
</center>

<a name="terminal"></a>
<a name="arriba"></a>

<h1>Objetos</h1>
Objeto es cualquier cosa que el jugador puede manipular dentro del juego, por ejemplo: una manzana que puede comer, una llave que se puede usar para abrir una puerta, una espada para pelear, etc.<p>
En nuestro juego, que es bastante simple, usaremos los siguientes objetos (no todos ellos tendr&aacute;n una funci&oacute;n en el juego finalizado):<br><br>
<blockquote>
Objeto 0 - una antorcha encendida<br>
Objeto 1 - una bolsa<br>
Objeto 2 - un emparedado<br>
Objeto 3 - una manzana<br>
Objeto 4 - un billete de autob&acute;s<br>
Objeto 5 - una piedra<br>
Objeto 6 - un anorak<br>
Objeto 7 - una antorcha apagada<br>
</blockquote><br><br>
Muy importante: la antorcha se trata como dos objetos separados. Cambiaremos de uno al otro cuando el jugador la apague o la encienda.<p>
Otro punto a destacar es el hecho de que PAW, al hacer un inventario, muestra la descipci&oacute;n de los objetos eliminando la primera palabra ("una"). Para evitar esto, se deber&aacute; insertar al comienzo de cada descripci&oacute;n un c&oacute;digo de cambio de color, por ejemplo [ EXTRA y 0 ] para poner el papel negro. Este truco evita que PAW se coma la primera palabra.<p>
La opci&oacute;n 0 del men&uacute; sirve, como muy agudamante habr&aacute;s deducido, para poner las descripciones de los objetos, de una forma similar a como hemos puesto las descripciones de las localidades.<p>
Veremos que tambi&eacute;n existe un objeto 0 si se usa la opci&oacute;n P, para hacer una lista de ellos.<p>
Por lo tanto hay que corregir esta entrada del objeto 0 tecleando (A 0) y usando un color de tinta diferente. Por ejemplo, si queremos usar el color cyan, hay que pasar al modo extendido o extra en el 128 y luego teclear al mismo tiempo CAPS SHIFT + 5.<p>
No te olvides de volver al color blanco otra vez. Esto se consigue con el modo extendido y luego CAPS SHIFT y 7 al mismo tiempo. Esto debe hacerse al final de cada texto.<p>
Volvamos al men&uacute; principal para que le podamos decir a PAW m&aacute;s cosas sobre nuestros objetos. Con la opci&oacute;n I tenemos donde est&aacute; cada objeto inicialmente, es decir, cuando la aventura comienza.<p>
Vemos que no hay opci&oacute;n de insertar puesto que eso ya queda hecho autom&aacute;ticamente por PAW cuando en la tabla O se ha puesto un objeto. Date cuenta que corregir (Amend) (A) tiene dos par&aacute;metros, el n&uacute;mero del objeto y su posici&oacute;n.<p>
Esta opci&oacute;n tiene varios valores especiales que son muy importantes (son localidades que no existen):
<ul>
<li>252 es para objetos no creados, por ejemplo, que no existen todavia dentro del juego.</li>
<li>253 tiene todos los objetos llevados encima (puestos) por el jugador.</li>
<li>254 tiene todos los objetos llevados por el jugador, pero no puestos encima.</li>
</ul>
Por ejemplo, si queremos hacer de la antorcha encendida un objeto no creado hay que teclear [A 0 252] y como antes estaba como objeto llevado, el mensaje AMEND que significa corregido ser&aacute; impreso para mostrar que PAW ha hecho la correcci&oacute;n.<p>
Tecleemos ahora las siguientes posicionoes iniciales, pero sin poner los comentarios que van despues del punto y coma (;).<p>
Luego, cuando hayas terminado, usa la opci&oacute;n P para corregirlos.<p><br>	
<blockquote>
<table>
<tr><td>Objeto 1</td><td>2</td><td>; porque la bolsa se encuentra en la parada del autob&uacute;s.</td></tr>
<tr><td>Objeto 2</td><td>254</td><td>; porque el jugador lleva el emparedado</td></tr>
<tr><td>Objeto 3</td><td>254</td><td>; y la manzana</td></tr>
<tr><td>Objeto 4</td><td>8</td><td>; significa que el billete est&aacute; arriba del &aacute;rbol</td></tr>
<tr><td>Objeto 5</td><td>3</td><td>; una piedra que est&aacute; en la hierba</td></tr>
<tr><td>Objeto 6</td><td>253</td><td>; porque el jugador lleva puesto encima el anorak</td></tr>
<tr><td>Objeto 7</td><td>254</td><td>; y lleva consigo la antorcha apagada</td></tr>
</table>
</blockquote><br>
Ahora vamos a decirle a PAW m&aacute;s cosas acerca de los objetos; por ejemplo, su peso relativo, o si son capaces de contener a otros objetos, o si el jugador puede llevarlos puestos encima.<p>
Volvemos al men&uacute; principal y tecleamos la opci&oacute;n X; con ello pasamos al men&uacute; de peso de objetos, que tambi&eacute;n nos permite poner los otros dos atributos (contenedor y llevable encima).<p>
Como siempre, PAW ya ha creado una entrada en esta tabla para todos los objetos que se han insertado previamente. De hecho ya le ha dado a cada objeto el peso de una unidad, no contenedor, y no llevable. Esto lo asigna a cada objeto por defecto (por defecto significa el que PAW le da, si tu no le das ning&uacute;n valor).<p>
Necesitamos probablemente corregir el anorak y la bolsa, puesto que el jugador es capaz de llevar puesto encima el anorak (de hecho el jugador est&aacute; haciendo esto desde el principio cuando comienza el juego) y la bolsa debe ser capaz de contener otros objetos.<p>
Adem&aacute;s, el anorak y la bolsa son mucho mas pesados (relaticamente) que los otros objetos y hay que cambiarles su valor a 3 unidades cada uno.<p>
Cuando se teclea A para corregir aparecen 3 valores; uno es el n&uacute;mero de objeto, otro es el peso unitario del objeto, y finalmente el tercero son los otros atributos, que pueden ser:<br><br>
<blockquote>
0 = ninguno.<p>
1 = contenedor para otros objetos.<p>
2 = el juegador puede pon&eacute;rselo y quit&aacute;rselo.<p>
3 = un contenedor que puede ser puesto y quitado (ejemplo: unos pantalones que tienen un bolsillo).<p>
</blockquote><br>
Volvamos a nuestra bolsa (objeto 1), que es un contenedor y pesa tres unidades. Entonces necesitamos teclear [ A 1 3 1 ] (NO TE OLVIDES DE PONER LOS ESPACIOS).<p>
El anorak no tiene bolsillos (por lo menos en este juego no los tiene), pero puede ser llevado encima y quitado, por lo tanto hay que teclear [ A 6 3 2 ].<p>
Usemos la opci&oacute;n P para examinar las entradas que hemos hecho, y deben ser:<br><br>
<blockquote>
Objeto 0&nbsp;&nbsp;&nbsp;Pesa 1<br>
Objeto 1&nbsp;&nbsp;&nbsp;Pesa 3&nbsp;&nbsp;&nbsp;C&nbsp;&nbsp;&nbsp;;C significa que es un contenedor. (1)<br>
Objeto 2&nbsp;&nbsp;&nbsp;Pesa 1<br>
Objeto 3&nbsp;&nbsp;&nbsp;Pesa 1<br>
Objeto 4&nbsp;&nbsp;&nbsp;Pesa 1<br>
Objeto 5&nbsp;&nbsp;&nbsp;Pesa 1<br>
Objeto 6&nbsp;&nbsp;&nbsp;Pesa 3&nbsp;&nbsp;&nbsp;WR&nbsp;&nbsp;&nbsp;;WR significa que se puede poner y quitar. (2)<br>
Objeto 7&nbsp;&nbsp;&nbsp;Pesa 1<br>
<br><br>
</blockquote>
<a href="files/air5-1.tar.gz">Demostraci&oacute;n AIR</a>
<br><br>
Ahora podemos probar la aventura otra vez para asegurarnos de que todos los objetos est&eacute;n donde tienen que estar. Pero todav&iacute;a no podemos hacer nada con ellos, necesitamos decirle a PAW que palabra describe a cada objeto.<p>
Tambi&eacute;n es el momento de hacer un SAVE de la Base de Datos, pero teniendo el cuidado de que sea en una nueva secci&oacute;n de la cinta y usando un diferente n&uacute;mero de versi&oacute;n.
<p><br><br>
<a href="files/air5-2.tar.gz">Demostraci&oacute;n AIR</a><br><br>
<a href="files/tzx5.tzx">Base de datos hasta el momento (nombre 'prueba2')</a>

<p><br>
<center>
<a href="paws4.php">[Anterior]</a> - 
<a href="paws6.php">[Siguiente]</a><br><br>
</center>
<a href="#arriba">[Ir arriba]</a><br>
<a href="../paws.php">[Pgina sobre PAWS]</a><br>

<p>
<?php include "../../../end.php"; ?>

</div>

</body>
</html>

