<DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html>
<head>
 <title>Manual de PAWS</title>
 <link rel="stylesheet" type="text/css"
       href="../../../css/default.css" title="CSS por defecto">
</head>
<body>

<div id="menu">
<?php
  $seccion="spectrum";
  $subseccion="aventura";
  include "../../../menu.php";
?>
</div>


<div id="central">
<a name="arriba"></a>


<h1>Manual de PAWS (VI)</h1>

<center>
<a href="paws5.php">[Anterior]</a> -
<a href="paws7.php">[Siguiente]</a><br><br>
</center>

<a name="terminal"></a>
<a name="arriba"></a>


<h1>Vocabulario</h1>
Tiene un men&uacute; m&aacute;s complejo que los que hemos visto hasta ahora, pero la mayor&iacute;a de las entradas son solo recordatorios de las opciones a tu disposici&oacute;n.<p>
El Vocabulario es una lista de las palabras que PAW puede reconocer si el jugador las teclea durante el juego. Por lo tanto, cualquier palabra que no est&eacute; en esta tabla no tendr&aacute; ning&uacute;n efecto.<p>
Hemos dejado un vocabulario inicial que ya contiene los verbos, nombres, etc., m&aacute; usados en las aventuras.<p>
Cada etrada para una palabra consiste en un m&aacute;ximo de cinco letras que, o bien cubren la palabra completa, por ejemplo NORTE, o son las cinco primeras letras de otra palabra m&aacute;s larga, por ejemplo <i>describir</i>, seguido del valor para esa palabra y del tipo de palabra (por ejemplo: Nombre, Verbo, etc.).<p>
El usar solamente cinco letras para guardar una palabra reduce la cantidad de memoria requerida para guardar el vocabulario entero; tambi&eacute;n reduce la longitud de los INPUTS del jugador, y acelera la b&uacute;squeda de palabras por el propio PAW. Adem&aacute;s, cinco letras son suficientes para establecer una diferencia entre la mayor&iacute;a de las palabras usadas corrientemente.<p>
El men&uacute; permite la INSERCI&Oacute;N y el BORRADO (delete) de palabras; el LISTADO de entradas hechas para cada tipo de palabras, y la inspecci&oacute;n de sin&oacute;nimos.<p>
Si tecleamos S OESTE veremos que PAW muestra el sin&oacute;nimo O tambi&eacute;n.<p>
Si tecleamos P 2 tendremos una lista de todos los nombres que hay actualmente en PAEW (los n&uacute;meros que corresponden a cada tipo de palabra se muestran al lado derecho del men&uacute;).<p>
Tambi&eacute;n enconrtar&aacute;s que PAW tiene ya en su vocabulario todas las direcicones del comp&aacute;s y algunas otras &uacute;tiles.<p>
Necesitamos ahora aumentar el n&uacute;mero de NOMBRES para poder poner las palabras que representan nuestros objetos.<p>
Todos los nombres con un valor menor de 50 son nombres propios, por ejemplo: nombres de personajes o lugares, pero m&aacute;s especificamente, para PAW son nombres que no se pueden cambiar por la terminaci&oacute;n verbal <u>lo</u> i <u>la</u>.<p>
Explic&aacute;ndolo mejor: para mayor rapidez PAW detecta culaes palabras son nombres propios (menos de 50) y cuales pertenecen a objetos manejables (mayores de 50).<p>
En la frase "coge el martillo, golpea a Manolo en la cabeza y d&eacute;jalo", si has dado a Manolo un valor menor de 50 y a martillo uno mayor, PAW entiende que el <i>la</i> final del verbo se refiere al martillo.<p>
Otro ejemplo: en la frase "dale a Carlos una tortilla y quitasela" entender&aacute; que el <i>la</i> final se refiere a la tortilla.<p>
El <i>lo</i> o <i>la</i> tambi&eacute;n puede ponerse antes del verbo con id&eacute;nticos resultados.<p>
Otro hecho importante es que las palabras con valor inferior a 20 son nombres, y que si PAW no encuentra un verbo en la frase los convertir&aacute; temporalmente en verbos.<p>
Por ejemplo: la palabra NORTE es un nombre y puede ser usado en la frase "ir al norte"; pero tambi&eacute;n puede ser tecleada sola, en cuyo caso como tiene un valor inferior a 20 se comportar&aacute; como un verbo (o sea, que te vayas al norte).<p>
Finalmente, las palabras con un valor menor de 14se tomar&aacute;n siempre como palabras-movimiento (cualquier palabra que sea una direcci&oacute;n) y sirven para determinar el mensaje que PAW imprimir&aacute; si no se peude hacer nada con esa frase (por ejemplo, determinar&aacute; si te responde un "no puedo" o "no puedo ir en esa direcci&oacute;n").<p>
Hay que notar que esto de "menor de 14 es palabra-movimiento" se aplica tanto a verbos como a nombres convertibles en verbos.<p>
Puesto que todos nuestros objetos son manejables, les daremos un valor mayor de 49.<p>
<blockquote>
<table>
<tr><td>ANTORcha</td><td>50</td></tr>
<tr><td>BOLSA</td><td>51</td></tr>
<tr><td>EMPARedado</td><td>52</td></tr>
<tr><td>MANZAna</td><td>53</td></tr>
<tr><td>BILLEte</td><td>54</td></tr>
<tr><td>PIEDRa</td><td>55</td></tr>
<tr><td>ANORAk</td><td>56</td></tr>
</table>
</blockquote><br>
Usa la opci&oacute;n I para insertar estas 7 palabras como nombres (tipo 2). Por ejemplo, teclea [ I ANTOR 50 2 ], etc.<p>
Con P 2 se puede comprobar que estos nombres est&aacute;n ahora en el vocabulario.<p>
Tambi&eacute;n necesitaremos usar adjetivos para diferenciar entre las dos antorchas. Con P 3 podemos ver los adjetivos que PAW ya conoce.<p>
Si no est&aacute;n ENCENDIDO y APAGADO ins&eacute;rtalas procurando darles un n&uacute;mero alto, pues son poco usados, y as&iacute; PAW no tendr&aacute; que pasar a trav&eacute;s de ellos cada vez que busque una palabra m&aacute;s com&uacute;n, por ejemplo un nombre o un verbo.<p>
Todos los n&uacute;meros desde el 2 al 254, est&acute;n disponibles para cualquier tipo de palabra y no hay limitaci&oacute;n en el uso de sin&oacute;nimos.<p>
Si tratas de insertar una palabra que ya est&aacute; presente, PAW te lo avisar&aacute;, lo mismo que si tratas de borrar una que no est&eacute; presente.<p>
Ten en cuenta que PAW solo tomar&aacute; las primeras 5 letras cuando te refieras a una palabra e ignorar&aacute; el resot.<p>
Luego volveremos al Vocabulario, pero ahora vamos a decirle a PAW que plabras definen nuestros objetos. Porque hasta ahora hemos descrito cada objeto, cuanto pesa y donde comienza, pero no le hemos dicho a PAW que palabra identifica cada objeto.<p>
Volver al men&uacute; principal.<p>
<br>
<a href="files/air6-1.tar.gz">Demostraci&oacute;n AIR</a>
<br><br>
<a href="files/tzx6.tzx">Base de datos hasta el momento (nombre 'prueba3')</a>


<p><br>
<center>
<a href="paws5.php">[Anterior]</a> - 
<a href="paws7.php">[Siguiente]</a><br><br>
</center>
<a href="#arriba">[Ir arriba]</a><br>
<a href="../paws.php">[Pgina sobre PAWS]</a><br>

<p>
<?php include "../../../end.php"; ?>

</div>

</body>
</html>

