<DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html>
<head>
 <title>Manual de PAWS</title>
 <link rel="stylesheet" type="text/css"
       href="../../../css/default.css" title="CSS por defecto">
</head>
<body>

<div id="menu">
<?php
  $seccion="spectrum";
  $subseccion="aventura";
  include "../../../menu.php";
?>
</div>


<div id="central">
<a name="arriba"></a>


<h1>Manual de PAWS (IX)</h1>

<center>
<a href="paws8.php">[Anterior]</a> -
<a href="paws10.php">[Siguiente]</a><br><br>
</center>

<a name="terminal"></a>
<a name="arriba"></a>

<h1>Procesos y respuestas</h1><br>
<h2>La tabla de respuestas (R)</h2><br>
La  tabla de Respuestas (R) del men&uacute; principal es una forma especial de tabla de Procesos.<p>
Una tabla de procesos puede verse como un lenguaje de programaci&oacute;n secuencial (se ejecuta un comando cada turno). Las &oacute;rdenes que se llevan a cabo se llaman "CondAccs" porque se pueden dividir principlamente en dos grupos, condiciones y acciones.<p>
Antes mencionamos que el PARSER de PAW divide las sentencias en frases, las cuales son organizadas entonces en lo que conocemos como SL (sentencias l&oacute;gicas).<p>
En el caso de direcciones como NORTE (que es una sentencia l&oacute;gica por si sola), PAW usa la tabla de conexiones para descubrir hacia donde se ha de mover el jugador.<p>
ANTES, sin embargo, PAW mira en la tabla de RESPUESTAS para ver si hay alguna entrada en ella que se pueda asociar con la SL.<p>
Es muy importante que quede claro el concepto de que cada frase que el jugador teclee y PAW entienda, debe tener su corresponidiente entrada en la tabla de Respuestas, excepto por la mayor&iacute;a de los movimientos, que han sido ya puestos en la tabla de Conexiones.<p>
La parte m&aacute;s importante de una SL es el verbo, que muestra la intenci&oacute;n de la frase; la siguiente en importancia es el <i>primer nombre</i>, que muestra el sujeto de la SL. Por ejemplo, en "coger manzana", coger es el objetivo y manzana es el sujeto.<p>
Si ahora seleccionamos R del men&uacute; principal aparecer&aacute; el submen&uacute; de esa tabla.<p>
Tecleando P para mirar la tabla e ignorando de momento cualquier otra entrada, vamos a considerar la entrada que pone:<br>
<br><blockquote><b>
I&nbsp;&nbsp;&nbsp;_&nbsp;&nbsp;&nbsp;INVEN
</b></blockquote><br>
Las dos palabras (porque _ es una palabra) indican el verbo y el nombre respectivamente. Como I es un nombre convertible en verbo (como vimos en la secci&oacute;n de Vocabulario) esto significa que si se teclea por si solo, es decir, si es la &uacute;nica palabra que ha tecleado el jugador en la frase, ser&aacute; tomada como un verbo en la SL. La l&iacute;nea (_) indica que el nombre no es importante en esta entrada, significar&iacute;a como el "no palabra" que vimos en la tabla de objetos y palabras.<p>
Lo que esto significa es, que si el jugador teclea I solo, PAW lo equiparar con la primera entrada de la tabla de Respuestas que tenga la I, y ejecutar&aacute; la orden que se describa al lado de ella.<p>
Para ejecutar una sentencia, PAW tiene que ejecutar cada uno de los condacc (&oacute;rdenes) en una lista que ya tiene. Ahora viendo nuestro ejemplo la plabra I solamente tiene un condacc.<p>
<br>
<b>INVEN:</b> es una acci&oacute;n (la parte activa de un condacc). Y es la parte activa porque se encarga de hacer una lista de los objetos que el jugador est&aacute; llevando consigo o lleva puestos encima, en la pantalla. No te preocupes de momento de c&oacute;mo hacer esto, solo nos interesa saber que lo hace.<p>
Cuando tecleaste I (o INVENTARIO si lo has puesto como sin&oacute;nimo) durante la prueba del juego, fue esta entrada en la tabla de Respuestas la que caus&oacute; que pasase algo, porque se cre&oacute; por el PARSER una sentencia l&oacute;gica de "I _", que entonces PAW emparej&oacute; con la primera entrada en la tabla-respuesta.<p>
INVEN, despu&eacute;s de que ha hecho una lista de todos los objetos que lleves, ya le dice autom&aacute;ticamente a PAW que ha hecho algo, y cuando PAW descubre esto, busca en el PARSER otra sentencia l&oacute;gica, la cual el PARSER ofrece, decodificando las siguientes frases en el INPUT del jugador. PAW entonces coge esta nueva SL y la compara con todas las entradas que hay en la tabla de Respuestas, y as&iacute; sucesivamente.<p>
Este bucle (loop) se muestra en el diagrama 4 en forma de una carta de flujo que se puede seguir desde el cuadrado marcado con "comienzo". El bucle es bastante m&aacute;s complejo que lo que el diagrama te pueda parecer y de hecho se da una versi&oacute;n m&aacute;s completa en la gu&iacute;a t&eacute;cnica, pero de momento el diagrama 4 nos servir&aacute;.<p>
<br><center>
<table border="0">
<tr><td><img src="./img/img9-1.png"></td></tr>
<tr><th>Diagrama 4</th></tr>
</table>
<br></center>
Te aconsejamos fervientemente que vuelvas a leer los p&aacute;rrafos anteriores y estudies el diagrama, hasta que entiendas como PAW trabaja sobre una sentencia l&oacute;gica antes de funcionar.<p>
Vamos a considerar la segunda entrada de Respuestas:
<br><br>
<blockquote><b>
Hacer&nbsp;&nbsp;&nbsp;I&nbsp;&nbsp;&nbsp;INVEN
</b></blockquote>
<br>
como habr&aacute;s deducido h&aacute;bilmente, esta entrada toma en cuenta otra forma de la cual el jugador puede pedir una lista de objetos.<p>
Veamos ahora la entrada que pone QUIT _ (para hacer esto basta con apretar cualquier tecla excepto BREAK, ESPACIO o N):
<br><br>
<blockquote><b>
<table>
<tr><td><b>FIN</b></td><td><b>_</b></td><td><b>QUIT</b></td></tr>
<tr><td></td><td></td><td><b>TURNS</b></td></tr>
<tr><td></td><td></td><td><b>END</b></td></tr>
</table>
</b></blockquote>
<br>
Bien, FIN es un verbo en el vocabulario, as&iacute; que como la <i>m&iacute;nima frase que PAW considerar&aacute; v&aacute;lida es un verbo</i>, si FIN se teclea solo entonces ya el PARSER generar&aacute; una SL de "FIN _".<p>
En su b&uacute;squeda a trav&eacute;s de la tabla de Respuestas, PAW encontrar&aacute; la entrada que hemos visto m&aacute;s arriba y empezar&aacute; a ejecutar los condacc.<p>
QUIT es una condici&oacute;n (la parte condicionante de la palabra condacc). Una condici&oacute;n solo decide si PAW contin&uacute;a para llevar a cabo el siguiente <u>condacto de la lista</u>, es decir, no toma de por s&iacute; ninguna acci&oacute;n, sino una decisi&oacute;n.<p>
QUIT lo que hace es determinar si el siguiente condacto puede ser ejecutado, pregunt&aacute;ndole al jugador "Est&aacute;s seguro?". Si el contesta NO; entonces QUIT avisa a PAW que ha hecho "algo" y este ir&aacute; en busca de otra SL (dejando en paz QUIT).<p>
Esta es una forma un poco diferente de tratar las condiciones en PAW, pero QUIT es una condici&oacute;n bastante especial, como vereis en el futuro. Si el jugador teclea "SI" entonces QUIT no hace nada, y deja que PAW busque el siguiente condacc de la sentencia, que ser&aacute; entonces TURNS.<p>
<br>
<b>TURNS</b> es una acci&oacute;n que imprime "has hecho x movidas" o "has dado x &oacute;rdenes" en la pantalla, donde x es el n&uacute;mero de frases que el jugador ha tecleado desde el comienzo del juego. Aparte de este hecho, como t&uacute; no le has dicho a PAW que deje de buscar condaccs, entonces &eacute;ste continuar&aacute; buscando END.<p>
<br>
<b>END</b> es una acci&oacute;n tambi&eacute;n especial que imprime "apetece otro juego?", o "quieres jugar otra partida?" en la pantalla. Si el jugador teclea "SI", entoces END reiniciar&aacute; el juego con todos los objetos en sus posiciones iniciales, etc. Si el jugador dice "NO" entonces generar&aacute; un error "OK", lo cual le har&aacute; volver al men&uacute; editor de PAW.<p>
Si el men&uacute; editor de PAW no est&aacute; presente (por ejemplo, un juego ya terminado), entonces el computador hace un reset.<p>
MUY IMPORTANTE: Debes tener siempre una acci&oacute;n END en alguna parte del juego, porque si no, no podr&aacute;s volver a la secci&oacute;n editora tan f&aacute;cilmente cuando est&eacute;s probando el juego.<p>
Tendr&aacute;s que hacer uso de la tecla BREAK, la cual solamente trabaja mientras que PAW est&aacute; procesando, y como no es f&aacute;cil pillar a PAW haci&eacute;ndolo, porque es muy r&aacute;pido, te ser&aacute; muy dif&iacute;cil.<p>
Las otras entradas que ya est&aacute;n presentes en la base de datos, se hacen cargo de varios comandos estandarizados que los jugadores normalmente necesitar&aacute;n en la aventura.<p>
Los condaccs usados en las otras entradas se discuten m&aacute;s abajo. <br>
Te estar&aacute;s preguntando por qu&eacute; estas entradas est&aacute;n en una tabla y no forman parte ya de por s&iacute;de PAW, si son necesarias en cada juego.<p>
Pues bien, mi querido saltamontes, la raz&oacute;n es que, aparte del hecho de que es mucho m&aacute;s f&aacute;cil ponerlas en una tabla que en el propio juego, <b>TU JUEGO A LO MEJOR NO LAS NECESITA</b>, y de esta forma las puedes borrar cuando quieras.<p>
<br>
<b>DESC</b> es una acci&oacute;n. De hecho, es la que se usa en la entrada "M _" de la tabla. Y esta acci&oacute;n hace que PAW abandone la b&uacute;squeda por la tabla de respuestas y reDEScriba la localidad actual del jugador. Tambi&eacute;n tiene varios sin&oacute;nimos: mirar, describir, etc... en el Vocabulario.<p>
<br>
<b>SAVE</b> y <b>LOAD</b> son dos acciones que permiten hacer un SAVE y un RELOAD del estado actual del juego en cinta. La posici&oacute;n actual del juego incluye tambi&eacute;n cualquier otra pieza de informaci&oacute;n que se neceiste para restaurar exactamente el juego en el mismo estado en que estaba; ello incluye los valores de las banderas, las posiciones de los objetos, y mucha m&aacute;s informaci&oacute;n.<p>
No debes confundir aqu&iacute; los anglicismos SAVE y LOAD que hemos dejado en el vocabulario con las acciones SAVE y LOAD. Nosotros hemos incluido tambi&eacute;n otros sin&oacute;nimos, como GRABAR y CARGAR, en el Vocabulario, pero todos ellos usar&aacute;n las acciones SAVE y LOAD de la tabla de Respuestas.<p>
Es de notar que ambos SAVE y LOAD ya de por s&iacute; hacen una acci&oacute;n DESC cuando han terminado. Lo cual significa que cualquier <i>condacc que siga, ser&aacute; ignorado igualmente por el INPUT del jugador</i>.<p>
<br>
<b>RAMSAVE</b> y <b>RAMLOAD</b> son dos acciones similares a SAVE y LOAD, excepto que ellos usan un "buffer" (&aacute;rea de memoria libre) para guardar la posici&oacute;n del juego. Esto significa que no tienes que andar toqueteando cintas.<p>
Solamente una posici&oacute;n puede ser guardada, y como la guarda en la memoria, suponemos que sabes que si apagas el ordenador desaparecer&aacute;. Aunque de todos modos, esto debes hac&eacute;rselo ver claramente al jugador en las instrucciones.<p>
Tambi&eacute;n el &aacute;rea del buffer se pierde cuando vuelves al editor, porque t&uacute; puedes desear cambiar alg&uacute;n dise&ntilde;o del juego entre dos textos.<p>
El n&uacute;mero ligado a RAMLOAD es un par&aacute;metro, y le dice al condacc cuantas de las banderas debe restaurar de un RAMSAVE previo. Esto permite que la puntuaci&oacute;n y otras cosas se mantengan, aunque el jugador "haga trampas" en una parte es muy dif&iacute;cil del juego usando constantemente RAMSAVE y RAMLOAD.<p>
Ambas acciones son seguidas autom&aacute;ticamente por una acci&oacute;n DESC, puesto que a diferencia de SAVE y LOAD, ellas, por s&iacute; solas, continuar&aacute;n hasta el siguiente condacc.<p>
Si a PAW se le acaban los condaccs en una lista sin haberle aclarado que ya se ha hecho (done) algo, sencillamente "caer&aacute;" hasta el final, y al darse cuenta de esto, continuar&aacute; en su b&uacute;squeda de otro SL.<p>
Tambi&eacute;n dijimos que QUIT era una condici&oacute;n bastante especial. Para comenzar, es la &uacute;nica condici&oacute;n que busca informaci&oacute;n del jugador, y por otra parte, tambi&eacute;n le informa a PAW de que algo ha sido hecho si el jugador teclea "NO" (es decir, que no quiere abandonar el juego), lo cual hace que PAW comience a buscar otro nuevo SL.<p>
<b>MUY IMPORTANTE</b>: una condici&oacute;n normal, si "falla", sencillamente har&aacute; que PAW contin&uacute;e buscando en la tabla de respuestas otra condici&oacute;n que haga juego con la SL.<p>
Los otros condactos que est&aacute; usados se considerar&aacute;n ahora en relaci&oacute;n con las entradas de las cuales son parte. Para simplificar nuestra explicaci&oacute;n, debemos considerar la posici&oacute;n de un objeto en el juego.<p>
Puede estar en cuatro lugares:<br>
<blockquote>
<ul>
<li>AQUI: es la localidad actual del jugador (es el valor que se guardaba en la bandera 38, si recuerdas bien). Tiene el valor de 255.</li>
<li>LLEVADO PERO NO PUESTO</li>Localidad 254, que es una localidad imaginaria donde se ponen todos los objetos que el jugador lleve.</li>
<li>PUESTOS ENCIMA: Localidad 253, que es una localidad imaginaria donde todos los objetos que el jugador lleve puestos encima son guardados.</li>
<li>NO PRESENTES: En cualquier otro sitio!. Esto tambi&eacute;n incluir&aacute; la localidad 252, que es una localidad imaginaria donde todos los objetos que a&uacute;n no existen son guardados.</li>
</ul>
</blockquote>
<br><br>
<u>Resumiendo:</u><br>
<blockquote>
<table>
<tr><td>Aqu&iacute;</td><td>=</td><td>Localidad 255</td></tr>
<tr><td>Llevados</td><td>=</td><td>Localidad 254</td></tr>
<tr><td>Puestos encima</td><td>=</td><td>Localidad 254</td></tr>
<tr><td>No presentes</td><td>=</td><td>Localidad 252 = No creado todav&iacute;</td></tr>
</table>
</blockquote>
<br>Vamos a ver otras dos entradas de la tabla de Respuestas:<br>
<table>
<tr><td><b>COGE</b></td><td><b>TODO</b></td><td><b>DOALL</b></td><td><b>255</b></td><td>(Par&aacute;metros: Localidad donde est&aacute;s: Aqu&iacute,)</td></tr>
<tr><td><b>COGER</b></td><td><b><center>_</center></b></td><td><b>AUTOG</b></td></tr>
<tr><td></td><td></td><td><b>DONE</b></td></tr>
</table><br>
Estas dos entradas son las que permiten al jugador coger cualquier objeto. Coger un objeto significa cambiar su localidad desde AQUI (255) a LLEVADO(254).<p>
Ignoremos por ahora la entrada "coge todo" y vamos a estudiar la orden "COGER _".<p>
Como dijimos antes, esa l&iacute;nea baja significa "cualquier palabra", as&iacute; que no importa cual nombre teclee el jugador en una frase que contenga el COGER. La entrada COGER _ siempre casar&aacute; (esto es lo que se llama "cargando" o "preparando" uan entrada).<p>
Veamos la frase "coger la manzana": <i>la</i> ser&aacute; ignorada por PAW porque no est&aacute; en el Vocabulario, pero la SL ser&aacute; "coger manzana", y esto "cargar&aacute;" la entrada "COGER _" cuando PAW encuentre este condacto.<p>
<br>
<b>AUTOG</b> es una acci&oacute;n que AUTOm&aacute;ticamente coger&aacute; cualquier objeto que haya sido especificado por el nombre.<p>
Es donde la tabla de Palabras-Relacionadas con Objetos viene a funcionar. AUTOG mira a trav&eacute;s de esa tabla buscando una entrada que sea similar al nombre de la SL cuando la encuentre (manzana en nuestro ejemplo) entonces sabe el n&uacute;mero del objheto al cual se refiere (en el caso de la manzana es 3).<p>
Se asegura entonces de que la localidad actual de ese objeto sea AQUI que es (255) y la pasa a LLEVADA que es (254) y entonces imprime el mensaje "Ahora tengo el objeto _." donde la l&iacute;nea baja es reemplazada por la descripci&oacute;n del objeto actual, por ejemplo el que acaba de marcar el AUTOG.<p>
Si no encuentra ninguna entrada, entonces hay cinco posiblidades:<br>
<ol>
<li>El jugador ha intentado coger un objeto que ya lleva o tiene puesto, en cuyo caso el mensaje "Ya tengo el _" se imprime.</li>
<li>El jugador ha intentado coger un objeto que est&aacute; en la localidad AQUI NO, en cuyo caso se imprimir&aacute; el mensaje "Aqu&iacute; no hay uno de esos".</li>
<li>El jugador ha intentado coger algo que <u>no es un objeto</u>, pero que tiene una palabra en la tabla de Vocabulario (por ejemplo: puerta en nuestro juego de demostraci&oacute;n). Esto producir&aacute; el mensaje "No puedo hacer eso".</li>
<li>El jugador ha usado una palabra que no est&aacute; en el Vocabulario. Eso hace que el PARSER cree una SL de "COGER _" lo cual "carga" nuestra entrada de "COGER _" de todos modos. AUTOG asume que se trata de un nombre que describe un objeto (que puede o no existir) y entonces imprime el mensaje "No hay uno de esos aqu&iacute;"</li>
<li>El jugador no puede llevar m&aacute;s objetos, o el peso de este objeto sobrepasa el l&iacute;mite permitido paa el jugador, en cuyo caso aparecer&aacute; un mensaje que le informa de ello.</li>
</ol>
Si el AUTOG funciona, entonces PAW mira el siguiente condacc.<p>
<br>
<b>DONE</b> solamente le dice a PAW que la entrada ha terminado y que debe ir y buscar otra SL.<p>
<br>
Ahora miraremos la entrada <i>COGER TODO</i>. Como habr&aacute;s supuesto, esta entrada lo que hace es intentar coger todos los objetos que est&eacute;n en la localidad donde est&aacute;s t&uacute;.<p>
Si el jugador teclea la frase COGER TODO, el PARSER crear&aacute; una sentencia l&oacute;gica (SL) de "COGER TODO" y entonces har&aacute; pareja con la entrada presente en la tabla y PAW pasar&aacute;a a ejecutar la acci&oacute;n DOALL.<p>
<br>
<b>DOALL</b> es una acci&oacute;n que debe ser seguida con un par&aacute;metro. El par&aacute;metro nos da el n&uacute;mero de la localidad que usaremos.<p>
Lo que hace DOALL es buscar la lista de localidades en la cual se encuentra cada objeto, intentando encontrar entradas que sean iguales para el par&aacute;metro que se ha dado (que en este caso es 255, una localidad especial que significa que se use la localidad en la cual el jugado est&eacute; presente).<p>
Cuando encuentra uno similar, o el mismo, entonces se va a la tabla objetos relacionados con palabras para encontrar la palabra del Vocabulario que describe el n&uacute;mero del objeto.<p>
Esta palabra se pone en la actual SL (reemplazando el nombre todo) y una bandera se resetea para indicar que DOALL est&aacute; activo.<p>
Luego PAW sigue mirando el resto de la tabla de Respuestas buscando una entrada que haga juego con la SL recientemente modificada.<p>
Esta entrada ser&aacute; COGE _ (de la cual hemos hablado antes), que coger&aacute; el objeto que PAW haya buscado en la tabla de Objetos.<p>
Cuando haya terminado de hacer lo anterior, PAW se dar&aacute; cuenta de que todav&iacute;a permanece activo el DOALL, o sea, la bandera est&aacute; seteada y vuelve otraa vez a la entrada COGE TODO.<p>
En realidad lo que hace es saltar directamente a la acci&oacute;n DOALL y buscar otro objeto para generar una nueva SL, y as&iacute; sucesivamente para todos los objetos que est&eacute;n en la localidad especificada.<p>
Cuando se acaban los objetos, entonces la bandera se resetea para demostrarle a PAW que no est&aacute; activo el bucle y se le dice a PAW que busque otra SL.<p>
Esto podr&iacute;a parecer un modo bastante complejo de ejecutar esa acci&oacute;n, pero si examinamos a las entradas similares que tratan de PONERSE, QUITARSE y DEJAR, veremos que utilizan el mismo mecanismo.<p>
AUTOD, AUTOW y AUTOR trabajan de una manera muy similar a AUTOG, mientras que DOALL sencillamente se limita a cambiar la localidad actual para ejecutar las acciones.<p>
Por ejemplo, usa 254 (LLEVADAS) como el par&aacute;metro en la acci&oacute;n DROP y tembi&eacute;n en la acci&oacute;n WEAR (es decir, DOALL busca todos los objetos que lleves cuando intentas dejarlos caer o pon&eacute;rtelos encima); y utilizar&aacute; la localidad 253 (LLEVADO PUESTO ENCIMA) cuando se trata de quitarse todo.<p>
Si lo anterior te parece un poco complicado, no te preocupes de momento, porque DOALL es uno de los condactos m&aacute;s complejos de PAW y poco a poco lo ir&aacute;s entendiendo.<p>
Ser&iacute;a interesante que en este momento hagas un test de la aventura, y trates todos los comandos de "dejar todo", "coger todo", etc... para que el mecanismo se te haga m&aacute;s claro.

<p><br>
<center>
<a href="paws8.php">[Anterior]</a> - 
<a href="paws10.php">[Siguiente]</a><br><br>
</center>
<a href="#arriba">[Ir arriba]</a><br>
<a href="../paws.php">[Pgina sobre PAWS]</a><br>

<p>
<?php include "../../../end.php"; ?>

</div>

</body>
</html>

